# runner <img src="man/figures/hexlogo.png" align="right" height="139" />

<!-- badges: start -->

[![R-CMD-check](https://github.com/gogonzo/runner/workflows/R-CMD-check/badge.svg)](https://github.com/gogonzo/runner/actions)
[![CRAN](https://cranlogs.r-pkg.org/badges/runner)](https://CRAN.R-project.org/package=runner)
<!-- badges: end -->

Lightweight R package for rolling window operations. Apply any R
function on rolling windows with full control over window size, lag, and
time indices. Works with equally and unequally spaced time series.

## Installation

``` r
# CRAN
install.packages("runner")

# GitHub
devtools::install_github("gogonzo/runner")
```

## Example

``` r
library(runner)

# Rolling mean with window size 3
runner(1:10, k = 3, f = mean)
```

    ##  [1] 1.0 1.5 2.0 3.0 4.0 5.0 6.0 7.0 8.0 9.0

``` r
# Rolling regression on time series data
df <- data.frame(
  date = Sys.Date() + cumsum(sample(1:3, 20, TRUE)),
  y = rnorm(20),
  x = rnorm(20)
)

runner(
  x = df,
  k = "7 days",
  idx = df$date,
  f = function(data) coef(lm(y ~ x, data = data))[2]
)
```

    ##           x           x           x           x           x           x           x           x           x           x           x           x           x           x           x           x 
    ##          NA  5.97481674  1.49452100 -0.21575866  0.72053778  0.70082162  1.24506110  1.04075030  1.08250746  0.64303239  0.54936879  0.58570439 -0.78182096 -0.14576205 -0.49775101 -0.28316471 
    ##           x           x           x           x 
    ##  4.25927423  1.08657714  0.04363541 -0.15253300

## ----eval=FALSE---------------------------------------------------------------
# library(runner)
# 
# x <- sample(letters, 20, replace = TRUE)
# date <- Sys.Date() + cumsum(sample(1:5, 20, replace = TRUE)) # unequally spaced time series
# 
# runner(
#   x,
#   k = "7 days",
#   idx = date,
#   f = function(x) length(unique(x))
# )

## ----eval=FALSE---------------------------------------------------------------
# library(runner)
# 
# x <- cumsum(rnorm(20))
# date <- Sys.Date() + cumsum(sample(1:5, 20, replace = TRUE)) # unequaly spaced time series
# 
# runner(
#   x,
#   k = "week",
#   idx = date,
#   f = function(x) mean(x, trim = 0.05)
# )

## ----eval=FALSE---------------------------------------------------------------
# library(runner)
# 
# # sample data
# x <- cumsum(rnorm(20))
# data <- data.frame(
#   date = Sys.Date() + cumsum(sample(1:3, 20, replace = TRUE)), # unequally spaced time series,
#   y = 3 * x + rnorm(20),
#   x = cumsum(rnorm(20))
# )
# 
# # solution
# data$pred <- runner(
#   data,
#   lag = "1 days",
#   k = "2 weeks",
#   idx = data$date,
#   f = function(data) {
#     predict(
#       lm(y ~ x, data = data)
#     )[nrow(data)]
#   }
# )
# 
# 
# plot(data$date, data$y, type = "l", col = "red")
# lines(data$date, data$pred, col = "blue")

## ----eval=FALSE---------------------------------------------------------------
# library(runner)
# library(dplyr)
# 
# set.seed(3737)
# df <- data.frame(
#   user_id = c(rep(27, 7), rep(11, 7)),
#   date = as.Date(rep(c(
#     "2016-01-01", "2016-01-03", "2016-01-05", "2016-01-07",
#     "2016-01-10", "2016-01-14", "2016-01-16"
#   ), 2)),
#   value = round(rnorm(14, 15, 5), 1)
# )
# 
# df %>%
#   group_by(user_id) %>%
#   mutate(
#     v_minus7  = sum_run(value, 7, idx = date),
#     v_minus14 = sum_run(value, 14, idx = date)
#   )

## ----eval=FALSE---------------------------------------------------------------
# library(runner)
# library(dplyr)
# 
# df <- read.table(text = "  user_id       date category
#        27 2016-01-01    apple
#        27 2016-01-03    apple
#        27 2016-01-05     pear
#        27 2016-01-07     plum
#        27 2016-01-10    apple
#        27 2016-01-14     pear
#        27 2016-01-16     plum
#        11 2016-01-01    apple
#        11 2016-01-03     pear
#        11 2016-01-05     pear
#        11 2016-01-07     pear
#        11 2016-01-10    apple
#        11 2016-01-14    apple
#        11 2016-01-16    apple", header = TRUE)
# 
# df %>%
#   group_by(user_id) %>%
#   mutate(
#     distinct_7 = runner(category,
#       k = "7 days",
#       idx = as.Date(date),
#       f = function(x) length(unique(x))
#     ),
#     distinct_14 = runner(category,
#       k = "14 days",
#       idx = as.Date(date),
#       f = function(x) length(unique(x))
#     )
#   )

## ----eval=FALSE---------------------------------------------------------------
# library(dplyr)
# 
# x <- cumsum(rnorm(20))
# y <- 3 * x + rnorm(20)
# date <- Sys.Date() + cumsum(sample(1:3, 20, replace = TRUE)) # unequaly spaced time series
# group <- rep(c("a", "b"), each = 10)
# 
# 
# data.frame(date, group, y, x) %>%
#   group_by(group) %>%
#   run_by(idx = "date", k = "5 days") %>%
#   mutate(
#     alpha_5 = runner(
#       x = .,
#       f = function(x) {
#         coefficients(lm(x ~ y, x))[1]
#       }
#     ),
#     beta_5 = runner(
#       x = .,
#       f = function(x) {
#         coefficients(lm(x ~ y, x))[1]
#       }
#     )
#   )

## ----eval=FALSE---------------------------------------------------------------
# library(runner)
# library(dplyr)
# 
# Date <- seq(
#   from = as.Date("2014-01-01"),
#   to = as.Date("2019-12-31"),
#   by = "day"
# )
# market_return <- c(rnorm(2191))
# 
# AAPL <- data.frame(
#   Company.name = "AAPL",
#   Date = Date,
#   market_return = market_return
# )
# 
# MSFT <- data.frame(
#   Company.name = "MSFT",
#   Date = Date,
#   market_return = market_return
# )
# 
# df <- rbind(AAPL, MSFT)
# df$stock_return <- c(rnorm(4382))
# df <- df[order(df$Date), ]
# 
# df2 <- data.frame(
#   Company.name2 = c(replicate(450, "AAPL"), replicate(450, "MSFT")),
#   Event_date = sample(
#     seq(as.Date("2015/01/01"),
#       as.Date("2019/12/31"),
#       by = "day"
#     ),
#     size = 900
#   )
# )
# 
# 
# df2 %>%
#   group_by(Company.name2) %>%
#   mutate(
#     intercept = runner(
#       x = df[df$Company.name == Company.name2[1], ],
#       k = "180 days",
#       lag = "5 days",
#       idx = df$Date[df$Company.name == Company.name2[1]],
#       at = Event_date,
#       f = function(x) {
#         coef(
#           lm(stock_return ~ market_return, data = x)
#         )[1]
#       }
#     ),
#     slope = runner(
#       x = df[df$Company.name == Company.name2[1], ],
#       k = "180 days",
#       lag = "5 days",
#       idx = df$Date[df$Company.name == Company.name2[1]],
#       at = Event_date,
#       f = function(x) {
#         coef(
#           lm(stock_return ~ market_return, data = x)
#         )[2]
#       }
#     )
#   )

set.seed(11)
x1 <- sample(c(T, F), 100, replace = TRUE)
x2 <- sample(c(NA, T, F), 100, replace = TRUE)
k <- sample(1:100, 100, replace = TRUE)
lag <- sample(-15:15, 100, replace = TRUE)
idx <- cumsum(sample(c(1, 2, 3, 4), 100, replace = TRUE))
which2 <- function(x, arg_which = "last", na_rm = TRUE) {
  x <- if (!na_rm) {
    if (arg_which == "last") {
      ifelse(
        tail(which(x), 1) > tail(c(0, which(is.na(x))), 1),
        tail(which(x), 1), NA
      )
    } else if (arg_which == "first") {
      ifelse(
        head(which(x), 1) > head(c(0, which(is.na(x))), 1),
        head(which(x), 1), NA
      )
    }
  } else {
    if (arg_which == "last") {
      tail(which(x), 1)
    } else if (arg_which == "first") {
      head(which(x), 1)
    }
  }
  if (length(x) == 0) {
    x <- NA_integer_
  }
  return(x)
}

#        |--------]------->-----
expect_identical(
  which_run(x2),
  as.integer(runner(x2, f = which2))
)

expect_identical(
  which_run(x2, na_pad = TRUE),
  as.integer(runner(x2, f = which2, na_pad = TRUE))
)


expect_identical(
  which_run(x2, which = "first"),
  as.integer(runner(x2, function(x) which2(x, arg_which = "first")))
)

expect_identical(
  which_run(x2, which = "first", na_pad = TRUE),
  as.integer(
    runner(x2, function(x) which2(x, arg_which = "first"), na_pad = TRUE)
  )
)

expect_identical(
  which_run(x1, na_rm = FALSE),
  as.integer(runner(x1, function(x) which2(x, na_rm = FALSE)))
)


expect_identical(
  which_run(x1, which = "first", na_rm = FALSE),
  as.integer(
    runner(x1, function(x) which2(x, arg_which = "first", na_rm = FALSE))
  )
)

#    [...|----]---+------->-----
expect_equal(
  which_run(x2, lag = 3),
  as.integer(runner(x2, lag = 3, f = which2)))

expect_equal(
  which_run(x2, lag = 3, na_pad = TRUE),
  as.integer(runner(x2, lag = 3, f = which2, na_pad = TRUE)))

#        |--------+---]--->-----
expect_equal(
  which_run(x2, lag = -3),
  as.integer(runner(x2, lag = -3, f = which2)))

expect_equal(
  which_run(x2, lag = -3, na_pad = TRUE),
  as.integer(runner(x2, lag = -3, f = which2, na_pad = TRUE)))

#   [...]|--------+------->-----
expect_equal(
  which_run(x2, lag = 100),
  as.integer(runner(x2, lag = 100, f = which2)))

expect_equal(
  which_run(x2, lag = 100, na_pad = TRUE),
  as.integer(runner(x2, lag = 100, f = which2, na_pad = TRUE)))


expect_equal(
  which_run(x2, lag = -100),
  as.integer(runner(x2, lag = -100, f = which2)))

expect_equal(
  which_run(x2, lag = -100, na_pad = TRUE),
  as.integer(runner(x2, lag = -100, f = which2, na_pad = TRUE)))

#        |----[...]------->-----
out <- which_run(x2, k = 10)
test <- runner(x2, k = 10, f = which2)
test[10:100] <- test[10:100] + 10:100L - 10L
expect_equal(out, test)

out <- which_run(x2, k = 10, na_pad = TRUE)
test <- runner(x2, k = 10, f = which2, na_pad = TRUE)
test[10:100] <- test[10:100] + 10:100L - 10L
expect_equal(out, test)


out <- which_run(x2, k = 10, which = "first")
test <- runner(x2, k = 10, f = function(x) which2(x = x, arg_which = "first"))
test[10:100] <- test[10:100] + 10:100L - 10L
expect_equal(out, test)

out <- which_run(x2, k = 10, na_pad = TRUE, which = "first")
test <- runner(x2,
               k = 10,
               f = function(x) which2(x = x, arg_which = "first"),
               na_pad = TRUE)
test[10:100] <- test[10:100] + 10:100L - 10L
expect_equal(out, test)

#        [...|--------+-------[...]-----
out <- which_run(x2, k = 1)
test <- runner(x2, k = 1, f = which2)
test[1:100] <- test[1:100] + 1:100L - 1L
expect_equal(out, test)

out <- which_run(x2, k = 1, na_pad = TRUE)
test <- runner(x2, k = 1, f = which2, na_pad = TRUE)
test[1:100] <- test[1:100] + 1:100L - 1L
expect_equal(out, test)

#        [...|----]---+------->-----
out <- which_run(x2, k = 5, lag = 3)
test <- runner(x2, k = 5, lag = 3, f = which2)
test[(5 + 3):100] <- test[(5 + 3):100] + (5 + 3):100L - (5L + 3)
expect_equal(out, test)

out <- which_run(x2, k = 5, lag = 3, na_pad = TRUE)
test <- runner(x2, k = 5, lag = 3, f = which2, na_pad = TRUE)
test[(5 + 3):100] <- test[(5 + 3):100] + (5 + 3):100L - (5L + 3)
expect_equal(out, test)

out <- which_run(x2, k = 5, lag = 3, na_pad = TRUE, na_rm = FALSE)
test <- runner(x2, k = 5, lag = 3,
               f = function(x) which2(x, na_rm = FALSE), na_pad = TRUE)
test[(5 + 3):100] <- test[(5 + 3):100] + (5 + 3):100L - (5L + 3)
expect_equal(out, test)

#        |-----[--+---]--->-----
out <- which_run(x2, k = 5, lag = -3)
test <- runner(x2, k = 5, lag = -3, f = which2)
test[(5 - 3):100] <- test[(5 - 3):100] + (5 - 3):100L - (5L - 3)
expect_equal(out, test)

out <- which_run(x2, k = 5, lag = -3, na_pad = TRUE)
test <- runner(x2, k = 5, lag = -3, f = which2, na_pad = TRUE)
test[(5 - 3):100] <- test[(5 - 3):100] + (5 - 3):100L - (5L - 3)
expect_equal(out, test)

out <- which_run(x2, k = 5, lag = -3, na_pad = TRUE, na_rm = FALSE)
test <- runner(x2, k = 5, lag = -3,
               f = function(x) which2(x, na_rm = FALSE), na_pad = TRUE)
test[(5 - 3):100] <- test[(5 - 3):100] + (5 - 3):100L - (5L - 3)
expect_equal(out, test)

# idx-----
expect_equal(
  which_run(x2, lag = 3, idx = 1:100),
  which_run(x2, lag = 3))

expect_equal(
  which_run(x2, lag = 3, idx = 1:100, na_pad = TRUE),
  which_run(x2, lag = 3, na_pad = TRUE))

expect_equal(
  which_run(x2, lag = -3, idx = 1:100),
  which_run(x2, lag = -3))

expect_equal(
  which_run(x2, lag = -3, idx = 1:100, na_pad = TRUE),
  which_run(x2, lag = -3, na_pad = TRUE))

expect_equal(
  which_run(x2, k = 5, lag = 3, idx = 1:100),
  which_run(x2, k = 5, lag = 3))

expect_equal(
  which_run(x2, k = 5, lag = 3, idx = 1:100, na_pad = TRUE),
  which_run(x2, k = 5, lag = 3, na_pad = TRUE))

expect_equal(
  which_run(x2, k = 5, lag = -3, idx = 1:100),
  which_run(x2, k = 5, lag = -3))

expect_equal(
  which_run(x2, k = 5, lag = -3, idx = 1:100, na_pad = TRUE),
  which_run(x2, k = 5, lag = -3, na_pad = TRUE))

expect_equal(
  which_run(x2, k = 5, lag = -3, idx = 1:100),
  which_run(x2, k = 5, lag = -3))

expect_equal(
  which_run(x2, k = 5, lag = -3, idx = 1:100, na_pad = TRUE),
  which_run(x2, k = 5, lag = -3, na_pad = TRUE))


expect_equal(
  which_run(x2, k = 5, idx = 1:100),
  which_run(x2, k = 5))

expect_equal(
  which_run(x2, k = 5, idx = 1:100, na_pad = TRUE),
  which_run(x2, k = 5, na_pad = TRUE))

expect_equal(
  which_run(x2, k = k, lag = lag, idx = 1:100),
  which_run(x2, k = k, lag = lag))

expect_equal(
  which_run(x2, k = k, lag = lag, idx = 1:100, na_pad = TRUE),
  which_run(x2, k = k, lag = lag, na_pad = TRUE))

expect_equal(
  which_run(x2, k = k, lag = lag, idx = 1:100, na_rm = FALSE),
  which_run(x2, k = k, lag = lag, na_rm = FALSE))

expect_equal(
  which_run(x2, k = k, lag = lag, idx = 1:100, na_pad = TRUE, na_rm = FALSE),
  which_run(x2, k = k, lag = lag, na_pad = TRUE, na_rm = FALSE))

expect_equal(
  which_run(x2, k = k, lag = lag, idx = 1:100, na_rm = FALSE),
  which_run(x2, k = k, lag = lag, na_rm = FALSE))

expect_equal(
  which_run(x2, k = k, lag = lag, idx = 1:100, na_pad = TRUE, na_rm = FALSE),
  which_run(x2, k = k, lag = lag, na_pad = TRUE, na_rm = FALSE))

# Errors-----
expect_error(which_run(x1, which = "any"),
             "which value should be either")
expect_error(which_run(x1, k = (1:999)),
             "length of k and length of x differs")
expect_error(which_run(x1, k = c(NA, k[-1])),
             "Function doesn't accept NA values in k vector")

expect_error(which_run(x1, lag = (1:99)),
             "length of lag and length of x differs")
expect_error(which_run(x1, lag = c(NA, lag[-1])),
             "Function doesn't accept NA values in lag vector")

expect_error(which_run(x1, idx = (1:99)),
             "length of idx and length of x differs")
expect_error(which_run(x1, idx = c(NA, 1:99)),
             "Function doesn't accept NA values in idx vector")

set.seed(11)
x1 <- sample(c(1, 2, 3), 100, replace = TRUE)
x2 <- sample(c(NA, 1, 2, 3), 100, replace = TRUE)
k <- sample(1:100, 100, replace = TRUE)
lag <- sample(-15:15, 100, replace = TRUE)
idx <- cumsum(sample(c(1, 2, 3, 4), 100, replace = TRUE))
streak2 <- function(x, na_rm = TRUE) {  #nolint
  if (all(is.na(x))) return(NA)
  xx <- x[length(x)]
  astreak <- 0L
  if (na_rm) {
    for (i in rev(seq_along(x))) {
      if (is.na(x[i])) next
      if (is.na(xx)) xx <- x[i]
      if (x[i] != xx) break
      astreak <- astreak + 1L
    }
  } else {
    for (i in rev(seq_along(x))) {
      if (is.na(x[i])) return(NA)
      if (x[i] != xx) break
      astreak <- astreak + 1L
    }
  }

  if (astreak == 0) return(NA)
  return(astreak)
}

#       |--------]-------> ------
expect_identical(
  streak_run(x2),
  as.integer(runner(x2, f = streak2))
)

expect_identical(
  streak_run(x2, na_pad = TRUE),
  as.integer(runner(x2, f = streak2, na_pad = TRUE))
)

#   [...|----]---+-------> ------
expect_equal(
  streak_run(x2, lag = 3),
  runner(x2, lag = 3, f = streak2))

expect_equal(
  streak_run(x2, lag = 3, na_pad = TRUE),
  runner(x2, lag = 3, f = streak2, na_pad = TRUE))

#       |--------+---]---> ------
expect_equal(
  streak_run(x2, lag = -3),
  runner(x2, lag = -3, f = streak2))

expect_equal(
  streak_run(x2, lag = -3, na_pad = TRUE),
  runner(x2, lag = -3, f = streak2, na_pad = TRUE))

#  [...]|--------+-------> ------
expect_equal(
  streak_run(x2, lag = 100),
  as.numeric(runner(x2, lag = 100, f = streak2))
)

expect_equal(
  streak_run(x2, lag = 100, na_pad = TRUE),
  as.numeric(runner(x2, lag = 100, f = streak2, na_pad = TRUE))
)


expect_equal(
  streak_run(x2, lag = -100),
  runner(x2, lag = -100, f = streak2)
)

expect_equal(
  streak_run(x2, lag = -100, na_pad = TRUE),
  as.numeric(runner(x2, lag = -100, f = streak2, na_pad = TRUE))
)

#       |----[...]-------> ------
expect_equal(
  streak_run(x2, k = 3),
  runner(x2, k = 3, f = streak2))

expect_equal(
  streak_run(x2, k = 3, na_pad = TRUE),
  runner(x2, k = 3, f = streak2, na_pad = TRUE))

#       [...|--------+-------[...] ------
expect_equal(
  streak_run(x2, k = 1),
  runner(x2, k = 1, f = streak2))

expect_equal(
  streak_run(x2, k = 1, na_pad = TRUE),
  runner(x2, k = 1, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, k = 99),
  runner(x2, k = 99, f = streak2))

expect_equal(
  streak_run(x2, k = 99, na_pad = TRUE),
  runner(x2, k = 99, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, k = 100),
  runner(x2, k = 100, f = streak2))

expect_equal(
  streak_run(x2, k = 100, na_pad = TRUE),
  runner(x2, k = 100, f = streak2, na_pad = TRUE))

#       [...|----]---+-------> ------
expect_equal(
  streak_run(x2, k = 5, lag = 3),
  runner(x2, k = 5, lag = 3, f = streak2))

expect_equal(
  streak_run(x2, k = 5, lag = 3, na_pad = TRUE),
  runner(x2, k = 5, lag = 3, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, k = 5, lag = 3, na_rm = FALSE),
  runner(x2, k = 5, lag = 3, f = function(x) streak2(x, na_rm = FALSE)))

expect_equal(
  streak_run(x2, k = 5, lag = 3, na_pad = TRUE, na_rm = FALSE),
  runner(x2, k = 5, lag = 3,
         f = function(x) streak2(x, na_rm = FALSE), na_pad = TRUE))

#       |-----[--+---]---> ------
expect_equal(
  streak_run(x2, k = 5, lag = -3),
  runner(x2, k = 5, lag = -3, f = streak2))

expect_equal(
  streak_run(x2, k = 5, lag = -3, na_pad = TRUE),
  runner(x2, k = 5, lag = -3, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, k = 5, lag = -3, na_rm = FALSE),
  runner(x2, k = 5, lag = -3, f = function(x) streak2(x, na_rm = FALSE)))

expect_equal(
  streak_run(x2, k = 5, lag = -3, na_pad = TRUE, na_rm = FALSE),
  runner(x2, k = 5, lag = -3,
         f = function(x) streak2(x, na_rm = FALSE), na_pad = TRUE))

#       |--------+-[---]-> ------
expect_equal(
  streak_run(x2, k = 5, lag = -7),
  runner(x2, k = 5, lag = -7, f = streak2))

expect_equal(
  streak_run(x2, k = 5, lag = -7, na_pad = TRUE),
  runner(x2, k = 5, lag = -7, f = streak2, na_pad = TRUE))

#       |--------+[]-----> ------
expect_equal(
  streak_run(x2, k = 1, lag = -1),
  runner(x2, k = 1, lag = -1, f = streak2))

expect_equal(
  streak_run(x2, k = 1, lag = -1, na_pad = TRUE),
  runner(x2, k = 1, lag = -1, f = streak2, na_pad = TRUE))

#       |------[]+-------> ------
expect_equal(
  streak_run(x2, k = 1, lag = 1),
  runner(x2, k = 1, lag = 1, f = streak2))

expect_equal(
  streak_run(x2, k = 1, lag = 1, na_pad = TRUE),
  runner(x2, k = 1, lag = 1, f = streak2, na_pad = TRUE))

#various ------
expect_equal(
  streak_run(x2, k = k, lag = 1),
  runner(x2, k = k, lag = 1, f = streak2))

expect_equal(
  streak_run(x2, k = k, lag = 1, na_pad = TRUE),
  runner(x2, k = k, lag = 1, f = streak2, na_pad = TRUE))


expect_equal(
  streak_run(x2, k = 3, lag = lag),
  runner(x2, k = 3, lag = lag, f = streak2))

expect_equal(
  streak_run(x2, k = 3, lag = lag, na_pad = TRUE),
  runner(x2, k = 3, lag = lag, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, k = k, lag = lag),
  runner(x2, k = k, lag = lag, f = streak2))

expect_equal(
  streak_run(x2, k = k, lag = lag, na_pad = TRUE),
  runner(x2, k = k, lag = lag, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, k = k, lag = lag, na_rm = FALSE),
  runner(x2, k = k, lag = lag, f = function(x) streak2(x, na_rm = FALSE)))

expect_equal(
  streak_run(x2, k = k, lag = lag, na_rm = FALSE, na_pad = TRUE),
  runner(x2, k = k, lag = lag,
         f = function(x) streak2(x, na_rm = FALSE), na_pad = TRUE))

#date window ------
expect_equal(
  streak_run(x2, lag = 3, idx = idx, na_pad = FALSE),
  runner(x2, lag = 3, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, lag = 3, idx = idx, na_pad = TRUE),
  runner(x2, lag = 3, idx = idx, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, lag = -3, idx = idx, na_pad = FALSE),
  runner(x2, lag = -3, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, lag = -3, idx = idx, na_pad = TRUE),
  runner(x2, lag = -3, idx = idx, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, k = 3, idx = idx, na_pad = FALSE),
  runner(x2, k = 3, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, k = 3, idx = idx, na_pad = TRUE),
  runner(x2, k = 3, idx = idx, f = streak2, na_pad = TRUE))


expect_equal(
  streak_run(x2, lag = -1, idx = idx, na_pad = FALSE),
  runner(x2, lag = -1, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, lag = -1, idx = idx, na_pad = TRUE),
  runner(x2, lag = -1, idx = idx, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, lag = 100, idx = idx, na_pad = FALSE),
  runner(x2, lag = 100, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, lag = 100, idx = idx, na_pad = TRUE),
  runner(x2, lag = 100, idx = idx, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, lag = -100, idx = idx, na_pad = FALSE),
  runner(x2, lag = -100, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, lag = -100, idx = idx, na_pad = TRUE),
  runner(x2, lag = -100, idx = idx, f = streak2, na_pad = TRUE))


expect_equal(
  streak_run(x2, lag = lag, idx = idx, na_pad = FALSE),
  runner(x2, lag = lag, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, lag = lag, idx = idx, na_pad = TRUE),
  runner(x2, lag = lag, idx = idx, f = streak2, na_pad = TRUE))

expect_equal(
  streak_run(x2, k = 3, lag = 4, idx = idx, na_pad = FALSE),
  runner(x2, k = 3, lag = 4, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, k = 3, lag = 4, idx = idx, na_pad = TRUE),
  runner(x2, k = 3, lag = 4, idx = idx, f = streak2, na_pad = TRUE))


expect_equal(
  streak_run(x2, k = 3, lag = -4, idx = idx, na_pad = FALSE),
  runner(x2, k = 3, lag = -4, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, k = 3, lag = -4, idx = idx, na_pad = TRUE),
  runner(x2, k = 3, lag = -4, idx = idx, f = streak2, na_pad = TRUE))


expect_equal(
  streak_run(x2, k = k, lag = -4, idx = idx, na_pad = FALSE),
  runner(x2, k = k, lag = -4, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, k = k, lag = -4, idx = idx, na_pad = TRUE),
  runner(x2, k = k, lag = -4, idx = idx, f = streak2, na_pad = TRUE))


expect_equal(
  streak_run(x2, k = 4, lag = lag, idx = idx, na_pad = FALSE),
  runner(x2, k = 4, lag = lag, idx = idx, f = streak2, na_pad = FALSE))

expect_equal(
  streak_run(x2, k = 4, lag = lag, idx = idx, na_pad = TRUE),
  runner(x2, k = 4, lag = lag, idx = idx, f = streak2, na_pad = TRUE))

#data types ------
expect_equal(
  streak_run(as.integer(x2)),
  runner(as.integer(x2), f = streak2))

expect_equal(
  streak_run(as.character(x2)),
  runner(as.character(x2), f = streak2))

expect_equal(
  streak_run(c(TRUE, TRUE, FALSE, FALSE, TRUE)),
  runner(c(TRUE, TRUE, FALSE, FALSE, TRUE), f = streak2))

expect_equal(
  streak_run(as.integer(x2), k = 2),
  runner(as.integer(x2), k = 2, f = streak2))

expect_equal(
  streak_run(as.character(x2), k = 2),
  runner(as.character(x2), k = 2, f = streak2))

expect_equal(
  streak_run(c(TRUE, TRUE, FALSE, FALSE, TRUE), k = 2),
  runner(c(TRUE, TRUE, FALSE, FALSE, TRUE), k = 2, f = streak2))


#Errors ------
expect_error(streak_run(x1, k = (1:999)),
             "length of k and length of x differs")
expect_error(streak_run(x1, k = c(NA, k[-1])),
             "Function doesn't accept NA values in k vector")

expect_error(streak_run(x1, lag = (1:99)),
             "length of lag and length of x differs")
expect_error(streak_run(x1, lag = c(NA, lag[-1])),
             "Function doesn't accept NA values in lag vector")

expect_error(streak_run(x1, idx = (1:99)),
             "length of idx and length of x differs")
expect_error(streak_run(x1, idx = c(NA, 1:99)),
             "Function doesn't accept NA values in idx vector")

set.seed(as.integer(Sys.Date()))
x1 <- x2 <- 1:100
x2[sample(1:100, 10)] <- NA
k <- sample(1:100, 100, replace = TRUE)
lag <- sample(-15:15, 100, replace = TRUE)
idx <- cumsum(sample(c(1, 2, 3, 4), 100, replace = TRUE))
idx_date <- Sys.Date() + idx
at <- sample(1:100, 10)
at_date <- sample(idx, 10)
find_idx <- function(x, i, k, lag = 0, na_pad = FALSE) {
  n <- length(x)
  if (missing(k)) {
    if ((i - lag) > n) if (na_pad) return(integer(0))
    seq_along(x) %in% seq(0, i - lag)
  } else {
    if ((i - k - lag + 1) < 1 || (i - lag) > n) if (na_pad) return(integer(0))
    seq_along(x) %in% seq(i - lag - k + 1, i - lag)
  }
}
apply_fun <- function(x, i, k, lag = 0, na_pad = FALSE, fun, ...) {
  n <- length(x)
  values <- x[find_idx(x, i, k, lag, na_pad)]
  if (length(values) > 0) {
    fun(values, ...)
  } else {
    NA
  }
}

#       |--------]-------> ------
expect_identical(
  runner(x1, f = mean),
  sapply(seq_along(x1), function(i) apply_fun(x1, i = i, fun = mean)))

expect_identical(
  runner(x2, f = mean, na.rm = TRUE),
  sapply(
    seq_along(x2),
    function(i) apply_fun(x2, i = i, fun = mean, na.rm = TRUE)
  )
)

expect_identical(
  runner(x1, f = mean, idx = idx),
  sapply(seq_along(x1), function(i) apply_fun(x1, i = i, fun = mean)))


expect_identical(
  runner(x1, f = mean)[at],
  runner(x1, f = mean, at = at))

expect_identical(
  runner(x1, f = mean, idx = idx)[at],
  runner(x1, f = mean, at = at))

#   [...|----]---+-------> -------
expect_equal(
  runner(x1, lag = 3, f = mean),
  sapply(seq_along(x1), function(i) apply_fun(x1, i = i, lag = 3, fun = mean)))

expect_equal(
  runner(x1, lag = 3, f = mean, na_pad = TRUE),
  sapply(seq_along(x1), function(i) apply_fun(x1, i = i, lag = 3, fun = mean)))

expect_equal(
  runner(x1, lag = 3, f = mean)[at],
  runner(x1, lag = 3, f = mean, at = at))

expect_equal(
  runner(x1, lag = 3, f = mean, na_pad = TRUE)[at],
  runner(x1, lag = 3, f = mean, na_pad = TRUE, at = at))

#       |--------+---]---> -------
expect_equal(
  runner(x1, lag = -3, f = mean),
  sapply(seq_along(x1), function(i) apply_fun(x1, i = i, lag = -3, fun = mean)))

expect_equal(
  runner(x1, lag = -3, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(x1, i = i, lag = -3, fun = mean, na_pad = TRUE)
  )
)

expect_equal(
  runner(x1, lag = lag, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(x1, i = i, lag = lag[i], fun = mean)
  )
)

expect_equal(
  runner(x1, lag = lag, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(x1, i = i, lag = lag[i], na_pad = TRUE, fun = mean)
  )
)

expect_equal(
  runner(x1, lag = -3, f = mean)[at],
  runner(x1, lag = -3, f = mean, at = at))

expect_equal(
  runner(x1, lag = -3, f = mean, na_pad = TRUE)[at],
  runner(x1, lag = -3, f = mean, na_pad = TRUE, at = at))

expect_equal(
  runner(x1, lag = lag, f = mean)[at],
  runner(x1, lag = lag[at], f = mean, at = at))

expect_equal(
  runner(x1, lag = lag, f = mean, na_pad = TRUE)[at],
  runner(x1, lag = lag[at], f = mean, na_pad = TRUE, at = at))

#  [...]|--------+-------> -------
expect_equal(
  runner(x1, lag = 100, f = mean),
  sapply(seq_along(x1), function(i) apply_fun(x1, i = i, lag = 100, fun = mean))
)

expect_equal(
  runner(x1, lag = -100, f = mean),
  sapply(seq_along(x1), function(i) apply_fun(x1, i = i, lag = -100, fun = mean)))

expect_equal(
  runner(x1, lag = 100, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(x1, i = i, lag = 100, na_pad = TRUE, fun = mean)
  )
)

expect_equal(
  runner(x1, lag = -100, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(x1, i = i, lag = -100, na_pad = TRUE, fun = mean)
  )
)

expect_equal(
  runner(x1, lag = 100, f = mean)[at],
  runner(x1, lag = 100, f = mean, at = at))

expect_equal(
  runner(x1, lag = -100, f = mean)[at],
  runner(x1, lag = -100, f = mean, at = at))

expect_equal(
  runner(x1, lag = 100, f = mean, na_pad = TRUE)[at],
  runner(x1, lag = 100, f = mean, na_pad = TRUE, at = at))

expect_equal(
  runner(x1, lag = -100, f = mean, na_pad = TRUE)[at],
  runner(x1, lag = -100, f = mean, na_pad = TRUE, at = at))

#       |----[...]-------> -------
expect_equal(
  runner(x1, k = 3, f = mean),
  sapply(seq_along(x1), function(i) apply_fun(x1, i = i, k = 3, fun = mean)))

expect_equal(
  runner(x1, k = 3, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(x1, i = i, k = 3, na_pad = TRUE, fun = mean)
  )
)

expect_equal(
  runner(x1, k = k, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(x1, i = i, k = k[i], lag = 0, fun = mean)
    )
  )

expect_equal(
  runner(x1, k = 3, f = mean)[at],
  runner(x1, k = 3, f = mean, at = at))

expect_equal(
  runner(x1, k = 3, f = mean, na_pad = TRUE)[at],
  runner(x1, k = 3, f = mean, na_pad = TRUE, at = at))

expect_equal(
  runner(x1, k = k, f = mean)[at],
  runner(x1, k = k[at], f = mean, at = at))

#       [...|--------+-------[...] -------
expect_equal(
  runner(x1, k = 100, f = mean),
  sapply(seq_along(x1), function(i) apply_fun(fun = mean, x1, i = i, k = 100)))

expect_equal(
  runner(x1, k = 100, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 100, na_pad = TRUE)
  )
)

expect_equal(
  runner(x1, k = 101, f = mean),
  sapply(seq_along(x1), function(i) apply_fun(fun = mean, x1, i = i, k = 101)))

expect_equal(
  runner(x1, k = 101, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 101, na_pad = TRUE)
  )
)

expect_equal(
  runner(x1, k = 100, f = mean)[at],
  runner(x1, k = 100, f = mean, at = at))

expect_equal(
  as.numeric(runner(x1, k = 100, f = mean, na_pad = TRUE)[at]),
  as.numeric(runner(x1, k = 100, f = mean, na_pad = TRUE, at = at)))

expect_equal(
  runner(x1, k = 101, f = mean)[at],
  runner(x1, k = 101, f = mean, at = at))

expect_equal(
  runner(x1, k = 101, f = mean, na_pad = TRUE)[at],
  runner(x1, k = 101, f = mean, na_pad = TRUE, at = at))

#       [...|----]---+-------> -------
expect_equal(
  runner(x1, k = 5, lag = 3, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 5, lag = 3)
    )
  )

expect_equal(
  runner(x1, k = 5, lag = 3, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 5, lag = 3, na_pad = TRUE)
  )
)

expect_equal(
  runner(x1, k = 5, lag = 3, f = mean)[at],
  runner(x1, k = 5, lag = 3, f = mean, at = at))

expect_equal(
  runner(x1, k = 5, lag = 3, f = mean, na_pad = TRUE)[at],
  runner(x1, k = 5, lag = 3, f = mean, na_pad = TRUE, at = at))

#       |-----[--+---]---> -------
expect_equal(
  runner(x1, k = 5, lag = -3, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 5, lag = -3)
    )
  )

expect_equal(
  runner(x1, k = 5, lag = -3, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 5, lag = -3, na_pad = TRUE)
    )
  )



expect_equal(
  runner(x1, k = 5, lag = -3, f = mean)[at],
  runner(x1, k = 5, lag = -3, f = mean, at = at))

expect_equal(
  runner(x1, k = 5, lag = -3, f = mean, na_pad = TRUE)[at],
  runner(x1, k = 5, lag = -3, f = mean, na_pad = TRUE, at = at))

#       |--------+-[---]-> -------
expect_equal(
  runner(x1, k = 5, lag = -7, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 5, lag = -7)
    )
)

expect_equal(
  runner(x1, k = 5, lag = -7, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 5, lag = -7, na_pad = TRUE)
    )
  )


expect_equal(
  runner(x1, k = 5, lag = -7, f = mean)[at],
  runner(x1, k = 5, lag = -7, f = mean, at = at))

expect_equal(
  runner(x1, k = 5, lag = -7, f = mean, na_pad = TRUE)[at],
  runner(x1, k = 5, lag = -7, f = mean, na_pad = TRUE, at = at))

#       |--------+[]-----> -------
expect_equal(
  runner(x1, k = 1, lag = -1, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 1, lag = -1)
    )
  )

expect_equal(
  runner(x1, k = 1, lag = -1, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 1, lag = -1, na_pad = TRUE)
    )
  )



expect_equal(
  runner(x1, k = 1, lag = -1, f = mean)[at],
  runner(x1, k = 1, lag = -1, f = mean, at = at))

expect_equal(
  runner(x1, k = 1, lag = -1, f = mean, na_pad = TRUE)[at],
  runner(x1, k = 1, lag = -1, f = mean, na_pad = TRUE, at = at))

#       |------[]+-------> -------
expect_equal(
  runner(x1, k = 1, lag = 1, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 1, lag = 1)
    )
  )

expect_equal(
  runner(x1, k = 1, lag = 1, f = mean, na_pad = TRUE),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 1, lag = 1, na_pad = TRUE)
    )
  )


expect_equal(
  runner(x1, k = 1, lag = 1, f = mean)[at],
  runner(x1, k = 1, lag = 1, f = mean, at = at))

expect_equal(
  runner(x1, k = 1, lag = 1, f = mean, na_pad = TRUE)[at],
  runner(x1, k = 1, lag = 1, f = mean, na_pad = TRUE, at = at))

#various -------
expect_equal(
  runner(x1, k = k, lag = 1, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = k[i], lag = 1)
    )
  )

expect_equal(
  runner(x1, k = 3, lag = lag, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = 3, lag = lag[i])
    )
  )

expect_equal(
  runner(x1, k = length(x1), lag = lag, f = mean),
  sapply(
    seq_along(x1),
    function(i) apply_fun(fun = mean, x1, i = i, k = length(x1), lag = lag[i])
    )
  )

expect_equal(
  runner(x1, k = k, lag = lag, f = mean),
  sapply(window_run(x1, k = k, lag = lag), mean))



expect_equal(
  runner(x1, k = k, lag = 1, f = mean)[at],
  runner(x1, k = k[at], lag = 1, f = mean, at = at))

expect_equal(
  runner(x1, k = 3, lag = lag, f = mean)[at],
  runner(x1, k = 3, lag = lag[at], f = mean, at = at))

expect_equal(
  runner(x1, k = length(x1), lag = lag, f = mean)[at],
  runner(x1, k = length(x1), lag = lag[at], f = mean, at = at))

expect_equal(
  runner(x1, k = k, lag = lag, f = mean)[at],
  runner(x1, k = k[at], lag = lag[at], f = mean, at = at))

#date window -------
expect_equal(
  runner(x1, idx = idx, f = mean),
  sapply(window_run(x1, idx = idx), mean)
)

expect_equal(
  runner(x2, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, lag = 3, idx = idx, f = mean),
  sapply(window_run(x1, lag = 3, idx = idx), mean)
)

expect_equal(
  runner(x2, lag = 3, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, lag = 3, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, lag = -3, idx = idx, f = mean),
  sapply(window_run(x1, lag = -3, idx = idx), mean)
)

expect_equal(
  runner(x2, lag = -3, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, lag = -3, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, lag = -1, idx = idx, f = mean),
  sapply(window_run(x1, lag = -1, idx = idx), mean)
)

expect_equal(
  runner(x2, lag = -1, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, lag = -1, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, lag = -100, idx = idx, f = mean),
  sapply(window_run(x1, lag = -100, idx = idx), mean)
)

expect_equal(
  runner(x2, lag = -100, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, lag = -100, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, lag = lag, idx = idx, f = mean),
  sapply(window_run(x1, lag = lag, idx = idx), mean)
)

expect_equal(
  runner(x2, lag = -lag, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, lag = -lag, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, k = 3, lag = 3, idx = idx, f = mean),
  sapply(window_run(x1, k = 3, lag = 3, idx = idx), mean)
)

expect_equal(
  runner(x2, k = 3, lag = 3, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, k = 3, lag = 3, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, k = 3, lag = -3, idx = idx, f = mean),
  sapply(window_run(x1, k = 3, lag = -3, idx = idx), mean)
)

expect_equal(
  runner(x2, k = 3, lag = -3, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, k = 3, lag = -3, idx = idx, na_pad = TRUE), mean)
)


expect_equal(
  runner(x1, k = 3, lag = lag, idx = idx, f = mean),
  sapply(window_run(x1, k = 3, lag = lag, idx = idx), mean)
)

expect_equal(
  runner(x2, k = 3, lag = lag, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, k = 3, lag = lag, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, k = k, lag = lag, idx = idx, f = mean),
  sapply(window_run(x1, k = k, lag = lag, idx = idx), mean)
)

expect_equal(
  runner(x2, k = k, lag = lag, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, k = k, lag = lag, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, k = 3, lag = lag, idx = idx, f = mean),
  sapply(window_run(x1, k = 3, lag = lag, idx = idx), mean)
)

expect_equal(
  runner(x2, k = k, lag = 3, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, k = k, lag = 3, idx = idx, na_pad = TRUE), mean)
)

expect_equal(
  runner(x1, k = k, lag = lag, idx = idx, f = mean),
  sapply(window_run(x1, k = k, lag = lag, idx = idx), mean)
)

expect_equal(
  runner(x2, k = k, lag = 3, idx = idx, f = mean, na_pad = TRUE),
  sapply(window_run(x2, k = k, lag = 3, idx = idx, na_pad = TRUE), mean)
)

#Function applied on other types -------
expect_silent(runner(as.integer(1:100), k = 5, f = length))
expect_silent(runner(as.integer(1:100), k = k, f = length))
expect_silent(runner(as.integer(1:100), k = k, idx, f = length))

expect_silent(
  runner(sample(letters, 100, replace = TRUE), k = 5, f = length)
)
expect_silent(runner(sample(letters, 100, replace = TRUE), k = k, f = length))
expect_silent(
  runner(sample(letters, 100, replace = TRUE), k = k, idx, f = length)
  )

expect_silent(
  runner(as.factor(sample(letters, 100, replace = TRUE)), k = 5, f = length)
)
expect_silent(
  runner(as.factor(sample(letters, 100, replace = TRUE)), k = k, f = length)
)
expect_silent(
  runner(
    as.factor(sample(letters, 100, replace = TRUE)), k = k, idx, f = length
  )
)

expect_silent(
  runner(as.Date(1:100, origin = "1970-01-01"), k = 5, f = length)
)
expect_silent(
  runner(as.Date(1:100, origin = "1970-01-01"), k = k, f = length)
  )
expect_silent(
  runner(as.Date(1:100, origin = "1970-01-01"), k = k, idx, f = length)
  )

#i/o type -------
log_input <- c(T, T, F, F)
int_input <- as.integer(1:4)
num_input <- as.numeric(1:4) + 0.5
cha_input <- letters[1:4]

log_function <- function(x) any(duplicated(x))
int_function  <- function(x) as.integer(length(x))
num_function  <- function(x) as.double(sum(x))
char_function <- function(x) paste(x, collapse = "-")

# <logical>
expect_identical(
  as.logical(c(FALSE, TRUE, TRUE, TRUE)),
  runner(log_input, f = log_function)
)

expect_identical(
  as.logical(c(FALSE, FALSE, FALSE, FALSE)),
  runner(int_input, f = log_function)
)

expect_identical(
  as.logical(c(FALSE, FALSE, FALSE, FALSE)),
  runner(num_input, f = log_function)
)

expect_identical(
  as.logical(c(FALSE, FALSE, FALSE, FALSE)),
  runner(cha_input, f = log_function)
)

# <integer>

expect_identical(
  as.integer(c(1, 2, 3, 4)),
  runner(log_input, f = int_function)
)

expect_identical(
  as.integer(c(1, 2, 3, 4)),
  runner(int_input, f = int_function)
)

expect_identical(
  as.integer(c(1, 2, 3, 4)),
  runner(num_input, f = int_function)
)

expect_identical(
  as.integer(c(1, 2, 3, 4)),
  runner(cha_input, f = int_function)
)

# <numeric>
expect_identical(
  as.numeric(c(1, 2, 2, 2)),
  runner(log_input, f = num_function)
)

expect_identical(
  as.numeric(c(1, 3, 6, 10)),
  runner(int_input, f = num_function)
)

expect_identical(
  as.numeric(c(1.5, 4, 7.5, 12)),
  runner(num_input, f = num_function))

expect_error(runner(cha_input, f = num_function))

# <character>
expect_identical(
  c("TRUE", "TRUE-TRUE", "TRUE-TRUE-FALSE", "TRUE-TRUE-FALSE-FALSE"),
  runner(log_input, f = char_function)
)

expect_identical(
  c("1", "1-2", "1-2-3", "1-2-3-4"),
  runner(int_input, f = char_function)
)

expect_identical(
  c("1.5", "1.5-2.5", "1.5-2.5-3.5", "1.5-2.5-3.5-4.5"),
  runner(num_input, f = char_function)
)

expect_identical(
  c("a", "a-b", "a-b-c", "a-b-c-d"),
  runner(cha_input, f = char_function)
)

#i/o type at -------
log_input <- c(T, T, F, F)
int_input <- as.integer(1:4)
num_input <- as.numeric(1:4) + 0.5
cha_input <- letters[1:4]

log_function <- function(x) any(duplicated(x))
int_function  <- function(x) as.integer(length(x))
num_function  <- function(x) as.double(sum(x))
char_function <- function(x) paste(x, collapse = "-")

at <- c(2, 3)
# <logical>
expect_identical(
  as.logical(c(FALSE, TRUE, TRUE, TRUE))[at],
  runner(log_input, f = log_function, at = at)
)

expect_identical(
  as.logical(c(FALSE, FALSE, FALSE, FALSE))[at],
  runner(int_input, f = log_function, at = at)
)

expect_identical(
  as.logical(c(FALSE, FALSE, FALSE, FALSE))[at],
  runner(num_input, f = log_function, at = at)
)

expect_identical(
  as.logical(c(FALSE, FALSE, FALSE, FALSE))[at],
  runner(cha_input, f = log_function, at = at)
)
# <integer>
expect_identical(
  as.integer(c(1, 2, 3, 4))[at],
  runner(log_input, f = int_function, at = at)
)
expect_identical(
  as.integer(c(1, 2, 3, 4))[at],
  runner(int_input, f = int_function, at = at)
)
expect_identical(
  as.integer(c(1, 2, 3, 4))[at],
  runner(num_input, f = int_function, at = at)
)
expect_identical(
  as.integer(c(1, 2, 3, 4))[at],
  runner(cha_input, f = int_function, at = at)
)

# <numeric>
expect_identical(
  as.numeric(c(1, 2, 2, 2))[at],
  runner(log_input, f = num_function, at = at)
)
expect_identical(
  as.numeric(c(1, 3, 6, 10))[at],
  runner(int_input, f = num_function, at = at)
)
expect_identical(
  as.numeric(c(1.5, 4, 7.5, 12))[at],
  runner(num_input, f = num_function, at = at)
)
expect_error(runner(cha_input, f = num_function, at = at))
# <character>
expect_identical(
  c("TRUE", "TRUE-TRUE", "TRUE-TRUE-FALSE", "TRUE-TRUE-FALSE-FALSE")[at],
  runner(log_input, f = char_function, at = at)
)
expect_identical(
  c("1", "1-2", "1-2-3", "1-2-3-4")[at],
  runner(int_input, f = char_function, at = at)
)

expect_identical(
  c("1.5", "1.5-2.5", "1.5-2.5-3.5", "1.5-2.5-3.5-4.5")[at],
  runner(num_input, f = char_function, at = at)
)
expect_identical(
  c("a", "a-b", "a-b-c", "a-b-c-d")[at],
  runner(cha_input, f = char_function, at = at)
)

#at date window -------
ids <- match(at_date, idx)
expect_equal(
  runner(x1, idx = idx, f = mean)[ids],
  runner(x1, idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x1, idx = idx, f = mean)[ids],
  runner(x1, idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x1, lag = 3, idx = idx, f = mean, na_pad = FALSE)[ids],
  runner(x1, lag = 3, idx = idx, at = at_date, f = mean, na_pad = FALSE)
)

expect_equal(
  runner(x1, lag = 3, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x1, lag = 3, idx = idx, at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x2, lag = 3, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, lag = 3, idx = idx, at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x1, lag = -3, idx = idx, f = mean)[ids],
  runner(x1, lag = -3, idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, lag = -3, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, lag = -3, idx = idx, at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x1, lag = -1, idx = idx, f = mean)[ids],
  runner(x1, lag = -1, idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, lag = -1, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, lag = -1, idx = idx, at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x1, lag = -100, idx = idx, f = mean)[ids],
  runner(x1, lag = -100, idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, lag = -100, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, lag = -100, idx = idx, at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x1, lag = lag, idx = idx, f = mean)[ids],
  runner(x1, lag = lag[ids], idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, lag = -lag, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, lag = -lag[ids], idx = idx, at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x1, k = 3, lag = 3, idx = idx, f = mean)[ids],
  runner(x1, k = 3, lag = 3, idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, k = 3, lag = 3, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, k = 3, lag = 3, idx = idx, at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x1, k = 3, lag = -3, idx = idx, f = mean)[ids],
  runner(x1, k = 3, lag = -3, idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, k = 3, lag = -3, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, k = 3, lag = -3, idx = idx, at = at_date, f = mean, na_pad = TRUE)
)


expect_equal(
  runner(x1, k = 3, lag = lag, idx = idx, f = mean)[ids],
  runner(x1, k = 3, lag = lag[ids], idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, k = 3, lag = lag, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, k = 3, lag = lag[ids], idx = idx,
         at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x1, k = k, lag = lag, idx = idx, f = mean)[ids],
  runner(x1, k = k[ids], lag = lag[ids], idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, k = k, lag = lag, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, k = k[ids], lag = lag[ids], idx = idx,
         at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x1, k = 3, lag = lag, idx = idx, f = mean)[ids],
  runner(x1, k = 3, lag = lag[ids], idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, k = k, lag = 3, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, k = k[ids], lag = 3, idx = idx,
         at = at_date, f = mean, na_pad = TRUE)
)

expect_equal(
  runner(x1, k = k, lag = lag, idx = idx, f = mean)[ids],
  runner(x1, k = k[ids], lag = lag[ids], idx = idx, at = at_date, f = mean)
)

expect_equal(
  runner(x2, k = k, lag = lag, idx = idx, f = mean, na_pad = TRUE)[ids],
  runner(x2, k = k[ids], lag = lag[ids], idx = idx,
         at = at_date, f = mean, na_pad = TRUE)
)

#at with difftime -------
at_date <- runner:::.seq_at(at = "1 months", idx = idx_date)
expect_identical(
  at_date,
  seq(min(idx_date), max(idx_date), by = "1 months")
)

expect_equal(
  runner(1:100, at = "1 months", idx = idx_date, f = function(x) max(x)),
  runner(1:100, at = at_date, idx = idx_date, f = function(x) max(x))
)

at_date <- runner:::.seq_at(at = "-1 months", idx = idx_date)
expect_identical(
  at_date,
  seq(max(idx_date), min(idx_date), by = "-1 months")
)
expect_equal(
  runner(1:100, at = "-1 months", idx = idx_date, f = function(x) max(x)),
  runner(1:100, at = at_date, idx = idx_date, f = function(x) max(x))
)

#k with difftime -------
expect_equal(
  runner(1:100, k = "2 weeks", idx = idx_date, f = function(x) x),
  runner(1:100, k = 14, idx = idx_date, f = function(x) x)
)

expect_equal(
  runner(1:100, k = "2 weeks", idx = idx_date, f = function(x) x),
  runner(1:100, k = as.difftime(2, units = "weeks"),
         idx = idx_date, f = function(x) x)
)

k_date <- sample(c("week", "day"), 100, replace = TRUE)
k_int <- ifelse(k_date == "week", 7L, 1L)

expect_equal(
  runner(1:100, k = k_date, idx = idx_date, f = function(x) x),
  runner(1:100, k = k_int, idx = idx_date, f = function(x) x)
)

expect_error(
  runner(1:100, k = "-1 weeks", idx = idx_date, f = function(x) x),
  "negative"
)

expect_error(
  runner(1:100,
         k = as.difftime(-1, units = "weeks"),
         idx = idx_date,
         f = function(x) x),
  "negative"
)

#lag with difftime -------
expect_equal(
  runner(1:100, lag = "week", idx = idx_date, f = function(x) x),
  runner(1:100, lag = 7, idx = idx_date, f = function(x) x)
)

expect_equal(
  runner(1:100, lag = "-1 weeks", idx = idx_date, f = function(x) x),
  runner(1:100, lag = -7, idx = idx_date, f = function(x) x)
)


expect_equal(
  runner(1:100, lag = "2 weeks", idx = idx_date, f = function(x) x),
  runner(1:100,
         lag = as.difftime(2, units = "weeks"),
         idx = idx_date,
         f = function(x) x)
)

expect_equal(
  runner(1:100, lag = "-2 weeks", idx = idx_date, f = function(x) x),
  runner(1:100,
         lag = as.difftime(-2, units = "weeks"),
         idx = idx_date,
         f = function(x) x)
)


lag_date <- sample(c("week", "day", "-2 weeks", "-2 days"), 100, replace = TRUE)
lag_int <- vapply(
  lag_date,
  function(x)
    switch(x, "week" = 7L, "day" = 1L, "-2 weeks" = -14L, "-2 days" = -2L),
  integer(1),
  USE.NAMES = FALSE
)


expect_equal(
  runner(1:100, k = 5, lag = lag_date, idx = idx_date, f = function(x) x),
  runner(1:100, k = 5, lag = lag_int, idx = idx_date, f = function(x) x)
)

#runner with df -------

#runner with matrix -------
data <- matrix(data = runif(100, 0, 1), nrow = 20, ncol = 5)
res <- runner(
  x = data,
  f = function(x) {
    tryCatch(
      cor(x),
      error = function(e) NA
    )
  })

expected <- sapply(
  X = 1:20,
  FUN = function(i) {
    tryCatch(
      cor(data[1:i, , drop = FALSE]),
      error = function(e) NA
    )
  }, simplify = TRUE)

expect_identical(res, expected)

#runner with xts -------
xts_object <- structure(
  .Data = matrix(
    data = runif(100, 0, 1),
    nrow = 20,
    ncol = 5,
    dimnames = list(NULL, c("open", "close", "high", "low", "volume"))
  ),
  index = structure(
    .Data = as.vector(seq.POSIXt(Sys.time(), by = "1 month", length.out = 20)),
    tclass = c("POSIXct", "POSIXt"),
    tzone = ""
  ),
  class = c("xts", "zoo")
)

res <- runner(
  x = xts_object,
  f = function(x) {
    tryCatch(
      x,
      error = function(e) NA
    )
  })

expected <- sapply(
  X = 1:20,
  FUN = function(i) {
    tryCatch(
      xts_object[1:i, , drop = FALSE],
      error = function(e) NA
    )
  },
  simplify = TRUE
)

expect_identical(res, expected)

#Parallel -------

#Errors -------
expect_error(runner(x = letters[1:5], f = ""))

expect_error(runner(list(1:10), k = 5, f = mean), "Invalid \\'x\\' type")

expect_error(runner(1:10, k = -5, f = mean),
             "k can't be negative")

expect_error(runner(1:10, k = (1:9), f = mean),
             "length of k and length of x differs")
expect_error(runner(1:10, k = c(NA, 1:9), f = mean),
             "Function doesn't accept NA values in k vector")

expect_error(runner(1:10, lag = (1:9), f = mean),
             "length of lag and length of x differs")
expect_error(runner(x1, k = k, lag = integer(0), idx = idx, f = mean),
             "length of lag should not be zero")
expect_error(runner(1:10, lag = c(NA, 1:9), f = mean),
             "Function doesn't accept NA values in lag vector")

expect_error(runner(1:10, idx = (1:9), f = mean),
             "length of idx and length of x differs")
expect_error(runner(1:10, idx = c(NA, 1:9), f = mean),
             "Function doesn't accept NA values in idx vector")
expect_error(runner(1:10, idx = sample(1:10), f = mean),
             "idx have to be in ascending order")


expect_error(
  runner(1:10, k = rep(5, 10), idx = 1:10, at = c(4, 5), f = mean),
  "length\\(k\\) should be 1 or equal to"
)

expect_error(
  runner(1:10, lag = rep(5, 10), idx = 1:10, at = c(4, 5), f = mean),
  "length\\(lag\\) should be 1 or equal to"
)

expect_identical(
  as.integer(fill_run(c(NA, NA, 1:10, NA, NA), run_for_first = TRUE)),
  as.integer(c(1, 1, 1:10, 10, 10))
)
expect_identical(
  fill_run(as.character(c(NA, NA, 1:10, NA, NA)), run_for_first = TRUE),
  as.character(c(1, 1, 1:10, 10, 10))
)

expect_identical(
  fill_run(as.complex(c(NA, NA, 1:10, NA, NA)), run_for_first = TRUE),
  as.complex(c(1, 1, 1:10, 10, 10))
)

expect_warning(fill_run(c(NA, NA, NA, NA)))

expect_equal(
  fill_run(factor(c(NA, NA, 1, 2, NA, NA, 2, 2, NA, NA, 1, NA, NA)),
           run_for_first = TRUE,
           only_within = TRUE),
  c(1, 1, 1, 2, 2, 2, 2, 2, NA, NA, 1, NA, NA)
)

expect_equal(
  fill_run(as.complex(c(NA, NA, 1, 2, NA, NA, 2, 2, NA, NA, 1, NA, NA)),
           run_for_first = TRUE,
           only_within = TRUE),
  as.complex(c(1, 1, 1, 2, 2, 2, 2, 2, NA, NA, 1, NA, NA))
)

expect_equal(
  fill_run(c(NA, NA, T, T, NA, NA, T, T, NA, NA, T, NA, NA),
           run_for_first = TRUE,
           only_within = TRUE),
  c(T, T, T, T, T, T, T, T, T, T, T, NA, NA)
)

# run_by ------
x <- data.frame(x = 1:2, b = letters[1:2])

expect_error(run_by(x, idx = b), "object 'b' not found")
expect_error(run_by(x, idx = "1 day"), "`idx` is invalid")
expect_error(run_by(x, idx = c("x", "b")), "`idx` is invalid")
expect_error(run_by(x, idx = difftime(Sys.Date() - 2, Sys.Date())), "`idx` is invalid")
expect_error(run_by(x, k = "-1 day"), "`k` is invalid")

x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, idx = "x")
attr(x, "idx") <- "x"
expect_identical(new_x, x, info = "run_by keeps `idx` as column name")

dates <- c(Sys.Date(), Sys.Date())
x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, idx = dates)
attr(x, "idx") <- dates
expect_identical(new_x, x, info = "run_by can hold a passed date vector")


time <- c(Sys.time(), Sys.time())
x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, idx = time)
attr(x, "idx") <- time
expect_identical(new_x, x, info = "run_by can hold a passed datetime vector")


x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, k = "x")
attr(x, "k") <- "x"
expect_identical(new_x, x, info = "run_by keeps `k` as column name")

difftime <- c(as.difftime(1, units = "secs"), as.difftime(2, units = "secs"))
x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, k = difftime)
attr(x, "k") <- difftime
expect_identical(new_x, x, info = "run_by keeps difftime vector as k attribute")


difftime <- as.difftime(1, units = "secs")
x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, k = difftime)
attr(x, "k") <- difftime
expect_identical(new_x, x, info = "run_by keeps difftime vector as k attribute")

difftime <- c("-1 secs", "2 weeks")
x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, k = difftime)
attr(x, "k") <- difftime
expect_identical(new_x, x, info = "run_by keeps difftime vector as k attribute")


difftime <- c("-1 secs")
x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, k = difftime)
attr(x, "k") <- difftime
expect_identical(new_x, x, info = "run_by keeps difftime vector as k attribute")


x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, idx = x$x)
attr(x, "idx") <- x$x
expect_identical(new_x, x)


x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(x, idx = 1:2)
attr(x, "idx") <- 1:2
expect_identical(new_x, x)


x <- data.frame(x = 1:2, b = letters[1:2])
new_x <- run_by(
  x,
  k = 1:2,
  lag = 1:2,
  idx = 1:2,
  na_pad = TRUE,
  at = 1:2
)

attr(x, "k") <- 1:2
attr(x, "lag") <- 1:2
attr(x, "idx") <- 1:2
attr(x, "na_pad") <- TRUE
attr(x, "at") <- 1:2
expect_identical(new_x, x)

# set arg from attr ------
data <- data.frame(
  x = 1:10,
  b = letters[1:10],
  kk = c(rep(2, 5), rep(5, 5))
)

x <- run_by(data, k = 1)
expect_equal(attr(x, "k"), 1)

x <- run_by(data, k = 1)
expect_equal(attr(x, "k"), 1)

k <- 1
new_x <- run_by(data, k = k)
attr(x, "k") <- k
expect_identical(new_x, x)


expect_error(
  run_by(1:10, idx = 1:10),
  "`run_by` should be used only with `data.frame`."
)

# run_by %>% runner -----
data <- data.frame(
  index = cumsum(sample(0:3, 10, replace = TRUE)),
  x = 1:10,
  b = letters[1:10],
  k = c(rep(2, 5), rep(5, 5)),
  lag = sample(0:3, 10, replace = TRUE)
)

# args by name
x <- run_by(data, idx = "index", k = "k")
expect_identical(
  runner(x, f = function(x) mean(x$x)),
  runner(
    data,
    f = function(x) mean(x$x),
    idx = data$index,
    k = "k"
  )
)

# args by name
x <- run_by(data, k = "k")
expect_error(
  runner(x, f = function(x) mean(x$x), k = "1 day"),
  "`k` is invalid, should be either"
)

x <- run_by(data, at = "index", idx = "index")
expect_identical(
  runner(x, f = function(x) mean(x$x)),
  runner(data, f = function(x) mean(x$x), at = "index", idx = "index")
)

x <- run_by(data, at = 1:3, idx = "index")
expect_error(
  runner(x, f = function(x) mean(x$x), at = "index2"),
  "`at` is invalid"
)

x <- run_by(data, at = "index")
names(x)[1] <- "wrong"
expect_error(runner(x, f = function(x) mean(x$x)), "`at` is invalid")


# all
x <- run_by(data, idx = "index", k = 5, lag = 2, na_pad = FALSE, at = 10)
expect_identical(
  runner(x, f = function(x) mean(x$x)),
  runner(data, f = function(x) mean(x$x), idx = data$index, k = 5, lag = 2, na_pad = FALSE, at = 10)
)


# argument by explicit value
x <- run_by(data, idx = "index", k = 5, lag = 2, na_pad = FALSE, at = 1:20)
expect_identical(
  runner(
    x,
    f = function(x) mean(x$x)
  ),
  runner(
    data,
    f = function(x) mean(x$x),
    idx = "index",
    k = 5,
    lag = 2,
    na_pad = FALSE,
    at = 1:20
  )
)

# few args by name / runner misc
x <- run_by(data, idx = "index", k = "k", lag = "lag", na_pad = FALSE)
expect_identical(
  runner(
    x,
    f = function(x) mean(x$x)
  ),
  runner(
    data,
    f = function(x) mean(x$x),
    idx = data$index,
    k = data$k,
    lag = "lag",
    na_pad = FALSE
  )
)

# arg by name, while obj of the same name
# in global env (by column name should be first)
index <- 1:10
x <- run_by(data, idx = "index", k = "k", lag = "lag", na_pad = FALSE)
expect_identical(
  runner(
    x,
    f = function(x) mean(x$x)
  ),
  runner(
    data,
    f = function(x) mean(x$x),
    idx = data$index,
    k = data$k,
    lag = data$lag,
    na_pad = FALSE
  )
)

x <- run_by(data, idx = data$index, k = "k", lag = "lag", na_pad = FALSE)
expect_identical(
  runner(
    x,
    f = function(x) mean(x$x)
  ),
  runner(
    data,
    f = function(x) mean(x$x),
    idx = "index",
    k = data$k,
    lag = data$lag,
    na_pad = FALSE
  )
)

# run_by %>% runner errors -------
data <- data.frame(
  index = cumsum(sample(0:3, 10, replace = TRUE)),
  x = 1:10,
  b = letters[1:10],
  k = c(rep(2, 5), rep(5, 5)),
  lag = sample(0:3, 10, replace = TRUE)
)

x <- run_by(data, idx = "index")
names(x)[1] <- "index2"
expect_error(
  runner(
    x,
    f = function(x) mean(x$x)
  ),
  "`idx` is invalid"
)

x <- run_by(data, idx = "index")
expect_error(
  runner(
    x,
    idx = "index2",
    f = function(x) mean(x$x)
  ),
  "`idx` is invalid"
)


x <- run_by(data, at = "index")
expect_error(
  runner(
    x,
    at = "1 day",
    f = function(x) mean(x$x)
  ),
  "`at` is invalid"
)

expect_error(
  run_by(data, k = as.factor(1:10)),
  "`k` is invalid, should be either:"
)

expect_error(
  run_by(data, idx = as.factor(1:10)),
  "`idx` is invalid"
)

expect_error(
  run_by(data, at = as.factor(1:10)),
  "`at` is invalid"
)

expect_error(
  run_by(data, lag = "1 day"),
  "`lag` is invalid, should be either"
)

expect_error(
  runner(
    data,
    k = "-1 day",
    f = function(x) mean(x$x)
  ),
  "`k` is invalid, should be either"
)

set.seed(1)
x <- 1L:30L
x2 <- as.numeric(1:30)
x3 <- sample(letters, 30, replace = TRUE)
x4 <- sample(c(TRUE, FALSE), 30, replace = TRUE)

lag  <- sample(-10:10, 30, replace = TRUE)
idx <- cumsum(sample(seq_len(5), 30, replace = TRUE))
lag_run2 <- function(x, lag = 1, idx = seq_along(x), nearest = FALSE) {
  fun <- function(x, k, idx, nearest, i) {
    res <- if (nearest) {
      window <- if (k > 0) {
        x[idx %in% seq(idx[i] - k, idx[i] - 1, by = 1)]
      } else if (k < 0) {
        x[idx %in% seq(idx[i] + 1, idx[i] - k, by = 1)]
      } else {
        return(x[i]);
      }
      if (length(window) > 0) {
        if (k > 0) window[1] else rev(window)[1]
      } else {
        NA
      }
    } else if (!nearest) {
      window <- if (k != 0) {
        x[idx == (idx[i] - k)]
      } else {
        return(x[i]);
      }
      res <- if (length(window) > 0) {
        if (k > 0) window[1] else rev(window)[1]
      } else {
        NA
      }
    }
    return(res)
  }
  sapply(seq_along(x), function(i) {
    if (length(lag) == 1) {
      fun(x, lag[1], idx, nearest, i)
    } else {
      fun(x, lag[i], idx, nearest, i)
    }

  })
}

# lag_run basic - different types ------

expect_identical(
  lag_run(x),
  c(NA, x[-30])
)

expect_identical(
  lag_run(as.character(x)),
  as.character(c(NA_character_, x[-30]))
)

expect_identical(
  lag_run(as.factor(letters)),
  c(NA_integer_, 1:25)
)

expect_identical(
  lag_run(as.integer(round(x))),
  as.integer(round(c(NA_integer_, x[-30])))
)

expect_identical(
  lag_run(as.complex(x)),
  as.complex(c(NA_complex_, x[-30]))
)

expect_identical(
  lag_run(x > 15),
  c(NA, x[-30] > 15)
)
# lag_run constant window" ---------
expect_identical(lag_run(x, lag = 3), c(rep(NA, 3), head(x, -3)))

expect_identical(lag_run(x2, lag = 3), c(rep(NA, 3), head(x2, -3)))

expect_identical(lag_run(x3, lag = 3), c(rep(NA, 3), head(x3, -3)))

expect_identical(lag_run(x4, lag = 3), c(rep(NA, 3), head(x4, -3)))

# lag_run moving window" ---------
expect_identical(lag_run(x, lag = lag), lag_run2(x, lag = lag))
expect_identical(lag_run(x, lag = lag, nearest = FALSE),
                 lag_run2(x, lag = lag, nearest = FALSE))

expect_identical(lag_run(x2, lag = lag), lag_run2(x2, lag = lag))
expect_identical(lag_run(x2, lag = lag, nearest = FALSE),
                 lag_run2(x2, lag = lag, nearest = FALSE))

expect_identical(lag_run(x3, lag = lag), lag_run2(x3, lag = lag))
expect_identical(lag_run(x3, lag = lag, nearest = FALSE),
                 lag_run2(x3, lag = lag, nearest = FALSE))

expect_identical(lag_run(x4, lag = lag), lag_run2(x4, lag = lag))
expect_identical(lag_run(x4, lag = lag, nearest = FALSE),
                 lag_run2(x4, lag = lag, nearest = FALSE))

# lag_run date idx window (nearest end)" -------
expect_identical(lag_run(x, lag = 3, idx = idx, nearest = TRUE),
                 lag_run2(x, lag = 3, idx = idx, nearest = TRUE))

expect_identical(lag_run(x, lag = 3, idx = idx, nearest = FALSE),
                 lag_run2(x, lag = 3, idx = idx, nearest = FALSE))

expect_identical(lag_run(x, lag = -3, idx = idx, nearest = TRUE),
                 lag_run2(x, lag = -3, idx = idx, nearest = TRUE))

expect_identical(lag_run(x, lag = -3, idx = idx, nearest = FALSE),
                 lag_run2(x, lag = -3, idx = idx, nearest = FALSE))

expect_identical(lag_run(x, lag = lag, idx = idx, nearest = TRUE),
                 lag_run2(x, lag = lag, idx = idx, nearest = TRUE))

expect_identical(lag_run(x, lag = lag, idx = idx, nearest = FALSE),
                 lag_run2(x, lag = lag, idx = idx, nearest = FALSE))



expect_identical(lag_run(x2, lag = 3, idx = idx, nearest = TRUE),
                 lag_run2(x2, lag = 3, idx = idx, nearest = TRUE))

expect_identical(lag_run(x2, lag = 3, idx = idx, nearest = FALSE),
                 lag_run2(x2, lag = 3, idx = idx, nearest = FALSE))

expect_identical(lag_run(x2, lag = -3, idx = idx, nearest = TRUE),
                 lag_run2(x2, lag = -3, idx = idx, nearest = TRUE))

expect_identical(lag_run(x2, lag = -3, idx = idx, nearest = FALSE),
                 lag_run2(x2, lag = -3, idx = idx, nearest = FALSE))

expect_identical(lag_run(x2, lag = lag, idx = idx, nearest = TRUE),
                 lag_run2(x2, lag = lag, idx = idx, nearest = TRUE))

expect_identical(lag_run(x2, lag = lag, idx = idx, nearest = FALSE),
                 lag_run2(x2, lag = lag, idx = idx, nearest = FALSE))


expect_identical(lag_run(x3, lag = 3, idx = idx, nearest = TRUE),
                 lag_run2(x3, lag = 3, idx = idx, nearest = TRUE))

expect_identical(lag_run(x3, lag = 3, idx = idx, nearest = FALSE),
                 lag_run2(x3, lag = 3, idx = idx, nearest = FALSE))

expect_identical(lag_run(x3, lag = -3, idx = idx, nearest = TRUE),
                 lag_run2(x3, lag = -3, idx = idx, nearest = TRUE))

expect_identical(lag_run(x3, lag = -3, idx = idx, nearest = FALSE),
                 lag_run2(x3, lag = -3, idx = idx, nearest = FALSE))

expect_identical(lag_run(x3, lag = lag, idx = idx, nearest = TRUE),
                 lag_run2(x3, lag = lag, idx = idx, nearest = TRUE))

expect_identical(lag_run(x3, lag = lag, idx = idx, nearest = FALSE),
                 lag_run2(x3, lag = lag, idx = idx, nearest = FALSE))


expect_identical(lag_run(x4, lag = 3, idx = idx, nearest = TRUE),
                 lag_run2(x4, lag = 3, idx = idx, nearest = TRUE))

expect_identical(lag_run(x4, lag = 3, idx = idx, nearest = FALSE),
                 lag_run2(x4, lag = 3, idx = idx, nearest = FALSE))

expect_identical(lag_run(x4, lag = -3, idx = idx, nearest = TRUE),
                 lag_run2(x4, lag = -3, idx = idx, nearest = TRUE))

expect_identical(lag_run(x4, lag = -3, idx = idx, nearest = FALSE),
                 lag_run2(x4, lag = -3, idx = idx, nearest = FALSE))

expect_identical(lag_run(x4, lag = lag, idx = idx, nearest = TRUE),
                 lag_run2(x4, lag = lag, idx = idx, nearest = TRUE))

expect_identical(lag_run(x4, lag = lag, idx = idx, nearest = FALSE),
                 lag_run2(x4, lag = lag, idx = idx, nearest = FALSE))

# errors ------
expect_error(lag_run(x, lag = (1:9)),
             "length of lag and length of x differs")
expect_error(min_run(x, lag = c(NA, lag[-1])),
             "Function doesn't accept NA values in lag vector")

expect_error(lag_run(x, idx = (1:9)),
             "length of idx and length of x differs")
expect_error(lag_run(x, idx = c(NA, 1:29)),
             "Function doesn't accept NA values in idx vector")
expect_error(lag_run(x, idx = sample(1:30)),
             "idx have to be in ascending order")

#!/bin/bash

URL="https://identity.staging.digital.ai"

while [[ $# -gt 0 ]]; do
  ARG_COUNT=$#
  case $1 in
    --user)
      PLATFORM_USER="$2"
      shift # past argument
      shift # past value
      ;;
    --pw)
      PLATFORM_PW="$2"
      shift # past argument
      shift # past value
      ;;
    -*|--*)
      echo "Unknown option $1"
      exit 1
      ;;
  esac
  if [ ${ARG_COUNT} -eq $# ]; then
    echo "Arguments have not been processed correctly, there should be fewer arguments remaining after processing one"
    exit 1
  fi
done

if [ -z ${PLATFORM_USER} ]; then
  echo "Use --user to define the user to create a token for"
  MISSING_REQUIRED=true
fi
if [ -z ${PLATFORM_PW} ]; then
  echo "Use --pw to define the password for the user to create a token for"
  MISSING_REQUIRED=true
fi

if [ ${MISSING_REQUIRED} ]; then
  exit 1
fi

# Create the bearer token to use in API requests
curl --silent --request POST "${URL}/auth/realms/digitalai/protocol/openid-connect/token" \
  --header 'Content-Type: application/x-www-form-urlencoded' \
  --data-urlencode 'grant_type=client_credentials' \
  --data-urlencode "client_secret=${PLATFORM_PW}" \
  --data-urlencode "client_id=${PLATFORM_USER}" \
  --data-urlencode 'scope=openid dai-svc' \
  | jq -r .access_token

#!/bin/bash

PLATFORM_URL="https://api.staging.digital.ai"
DEFAULT_WORKSPACE_ROOT="../.."

while [[ $# -gt 0 ]]; do
  ARG_COUNT=$#
  case $1 in
    --token)
      BEARER_TOKEN="$2"
      shift # past argument
      shift # past value
      ;;
    --version)
      IMAGE_VERSION="$2"
      shift # past argument
      shift # past value
      ;;
    --workspace)
      WORKSPACE_ROOT="$2"
      shift # past argument
      shift # past value
      ;;
    -*|--*)
      echo "Unknown option $1"
      exit 1
      ;;
  esac
  if [ ${ARG_COUNT} -eq $# ]; then
    echo "Arguments have not been processed correctly, there should be fewer arguments remaining after processing one"
    exit 1
  fi
done

if [ -z ${BEARER_TOKEN} ]; then
  echo "Use --token to define the bearer token to use in API requests"
  MISSING_REQUIRED=true
fi
if [ -z ${IMAGE_VERSION} ]; then
  echo "Use --version to define the version of the image of Digital.ai Release Runner to use in the agent runtime"
  MISSING_REQUIRED=true
fi
if [ ${MISSING_REQUIRED} ]; then
  exit 1
fi

if [ -z ${WORKSPACE_ROOT} ]; then
  WORKSPACE_ROOT=${DEFAULT_WORKSPACE_ROOT}
fi

HELM_DIR="${WORKSPACE_ROOT}"
GENERATED_YAML_FILE="${WORKSPACE_ROOT}/cloud-connector-k8s.yaml"

# Generate the yaml file for cloud-connector
helm repo add bitnami-repo https://charts.bitnami.com/bitnami
helm dependency update .
helm template runner ${HELM_DIR} -f ${HELM_DIR}/values-cloud-connector.yaml > ${GENERATED_YAML_FILE}

if [ -z ${GENERATED_YAML_FILE} ]; then
  echo "Failed to generate yaml file for k8s template in agent"
  exit 1
fi

# Determine the variables that need to be defined in the agent runtime definition
AGENT_VARIABLES=$(${WORKSPACE_ROOT}/scripts/dai-platform/get_cloud_connector_variables.sh --workspace "${WORKSPACE_ROOT}")

# Build the JSON for the POST body to create the agent runtime image
CREATE_AGENT_BODY=$(jq \
  --arg name "runner-${IMAGE_VERSION}" \
  --arg version "${IMAGE_VERSION}" \
  --argjson variables "${AGENT_VARIABLES}" \
  '.name = $name | .images[0].latest_tag = $version | .variables = $variables' \
  ${WORKSPACE_ROOT}/scripts/dai-platform/json/create_agent_runtime.json)

# Create a new agent runtime image
AGENT_RUNTIME_ID=$(curl --silent --request POST "${PLATFORM_URL}/workload/v1/agent_runtimes/" \
  --header "Authorization: Bearer ${BEARER_TOKEN}" \
  --header 'Content-Type: application/json' \
  --data-raw "${CREATE_AGENT_BODY}" \
  | jq -r .agent_runtime.id)

echo "Created agent runtime definition: ${AGENT_RUNTIME_ID}"

curl --silent --request PATCH "${PLATFORM_URL}/workload/v1/agent_runtimes/${AGENT_RUNTIME_ID}/template" \
  --header "Authorization: Bearer ${BEARER_TOKEN}" \
  --form "k8s_template=@${GENERATED_YAML_FILE}"

echo "Uploaded k8s template to agent runtime definition: ${AGENT_RUNTIME_ID}"

#!/bin/bash

while [[ $# -gt 0 ]]; do
  ARG_COUNT=$#
  case $1 in
    --workspace)
      WORKSPACE_ROOT="$2"
      shift # past argument
      shift # past value
      ;;
    --verbose)
      VERBOSE=true
      shift
      ;;
    -*|--*)
      echo "Unknown option $1"
      exit 1
      ;;
  esac
  if [ ${ARG_COUNT} -eq $# ]; then
    echo "Arguments have not been processed correctly, there should be fewer arguments remaining after processing one"
    exit 1
  fi
done

if [ ! -z ${VERBOSE} ]; then
  set -x
fi

if [ -z ${WORKSPACE_ROOT} ]; then
  WORKSPACE_ROOT=".."
fi

CLOUD_CONNECTOR_YAML=${WORKSPACE_ROOT}/values-cloud-connector.yaml
DEFAULT_YAML=${WORKSPACE_ROOT}/values.yaml

# Variable names to ignore, these are built into cloud connector
EXCLUDES=(
  "AGENT_IMAGE_release-runner"
  "DAI_NAMESPACE"
)

EXCLUDE_VARS=""
for exclude in ${EXCLUDES[*]}; do
  if [ ! -z ${EXCLUDE_VARS} ]; then
    EXCLUDE_VARS="${EXCLUDE_VARS}\|"
  fi
  EXCLUDE_VARS="${EXCLUDE_VARS}${exclude}"
done

# Find all the variables defined in the cloud connector yaml file that the client defines
VARIABLES=$(grep "\${" ${CLOUD_CONNECTOR_YAML} | awk -F '"' '{print $2}' | sort | uniq | grep -v ${EXCLUDE_VARS})

VARIABLE_JSON='{}'
for variable in ${VARIABLES}; do
  # Build string to find full paths to property that have the variable as the value
  yq_eval=$(echo '.. | select( . == "'${variable}'" ) | (path | join("."))')

  # Find the full paths to property in the cloud-connector yaml for the variable
  property=$(yq eval "${yq_eval}" ${CLOUD_CONNECTOR_YAML})

  # Look for the value used in the same property in the default yaml file to use a
  # default value in cloud connector
  default_value=$(yq ".${property}" ${DEFAULT_YAML})

  # Strip off braces from the variable to use as a property name in JSON
  key=$(echo ${variable} | sed -e 's/\${\(.*\)}/\1/')

  # If a value wasn't found in the default yaml file assume the client must define the value when creating
  # an agent instance so wrap name in angle braces to use as a value
  if [ -z ${default_value} ]; then
    default_value="<${key}>"
  fi
  VARIABLE_JSON=$(jq ". += { ${key} : \"${default_value}\" }" <<< ${VARIABLE_JSON})
done

echo ${VARIABLE_JSON}

#!/bin/bash

PLATFORM_URL="https://api.staging.digital.ai"

while [[ $# -gt 0 ]]; do
  ARG_COUNT=$#
  case $1 in
    --token)
      BEARER_TOKEN="$2"
      shift # past argument
      shift # past value
      ;;
    --version)
      IMAGE_VERSION="$2"
      IMAGE_NAME="runner-${IMAGE_VERSION}"
      shift # past argument
      shift # past value
      ;;
    -*|--*)
      echo "Unknown option $1"
      exit 1
      ;;
  esac
  if [ ${ARG_COUNT} -eq $# ]; then
    echo "Arguments have not been processed correctly, there should be fewer arguments remaining after processing one"
    exit 1
  fi
done

if [ -z ${BEARER_TOKEN} ]; then
  echo "Use --token to define the bearer token to use in API requests"
  MISSING_REQUIRED=true
fi
if [ -z ${IMAGE_VERSION} ]; then
  echo "Use --version to define the version of the image of Digital.ai Release Runner search for"
  MISSING_REQUIRED=true
fi

if [ ${MISSING_REQUIRED} ]; then
  exit 1
fi

# Search for agent by name
curl --silent --request GET "${PLATFORM_URL}/workload/v1/agent_runtimes?filter=name:${IMAGE_NAME}" \
  --header "Authorization: Bearer ${BEARER_TOKEN}" \
  | jq

#!/bin/bash

PLATFORM_URL="https://api.staging.digital.ai"
DEFAULT_WORKSPACE_ROOT="../.."

while [[ $# -gt 0 ]]; do
  ARG_COUNT=$#
  case $1 in
    --token)
      BEARER_TOKEN="$2"
      shift # past argument
      shift # past value
      ;;
    --version)
      IMAGE_VERSION="$2"
      shift # past argument
      shift # past value
      ;;
    --workspace)
      WORKSPACE_ROOT="$2"
      shift # past argument
      shift # past value
      ;;
    -*|--*)
      echo "Unknown option $1"
      exit 1
      ;;
  esac
  if [ ${ARG_COUNT} -eq $# ]; then
    echo "Arguments have not been processed correctly, there should be fewer arguments remaining after processing one"
    exit 1
  fi
done

if [ -z ${BEARER_TOKEN} ]; then
  echo "Use --token to define the bearer token to use in API requests"
  MISSING_REQUIRED=true
fi
if [ -z ${IMAGE_VERSION} ]; then
  echo "Use --version to define the version of the image of Digital.ai Release Runner to use in the agent runtime"
  MISSING_REQUIRED=true
fi

if [ ${MISSING_REQUIRED} ]; then
  exit 1
fi

if [ -z ${WORKSPACE_ROOT} ]; then
  WORKSPACE_ROOT=${DEFAULT_WORKSPACE_ROOT}
fi

# Search for agent by name
RESPONSE=$(${WORKSPACE_ROOT}/scripts/dai-platform/find_agent_runtime_by_name.sh --version ${IMAGE_VERSION} --token ${BEARER_TOKEN})

COUNT=$(jq -r '.pagination.total_available' <<< ${RESPONSE})

if [ ${COUNT} -eq 0 ]; then
  echo "There are no agents found for version ${IMAGE_VERSION}"
  exit 1
fi

for id in $(jq -r '.agent_runtimes[].id' <<< ${RESPONSE}); do
  echo "Deleting agent with id ${id}"
  curl --silent --request DELETE "${PLATFORM_URL}/workload/v1/agent_runtimes/${id}" \
    --header "Authorization: Bearer ${BEARER_TOKEN}"
done

#!/bin/bash

API_URL="https://api.staging.digital.ai"

####
#### Input variables, you can uncomment and hardcode values to bypass requiring the parameter when calling this script.
#### There may be other input variables that aren't listed here because they don't make sense to have hardcoded
####

#INPUT_USER=""                # username for tenant"
#INPUT_PW=""                  # password for tenant user"
#INPUT_DOMAIN=""              # vanity domain for the tenant
#INPUT_ACCOUNT=""             # account id for the tenant
#INPUT_ALIAS=""               # the alias property in the agent instance, also the name of the namespace used in k3d
####
# For values used in the "variables" property of the agent instance use exact same name as the variable the API needs
####
#RUNNER_REGISTRATION_TOKEN=""                         # api token from release used register runner

# Parse arguments to script
while [[ $# -gt 0 ]]; do
  ARG_COUNT=$#
  case $1 in
    --user) # Username for the tenant, only needed if bearer token is not supplied
      INPUT_USER="$2"
      shift # past argument
      shift # past value
      ;;
    --pw) # Password for the tenant, only needed if bearer token is not supplied
      INPUT_PW="$2"
      shift # past argument
      shift # past value
      ;;
    --token) # Bearer token for the tenant to use in API calls, or supply user and password so a token can be created
      INPUT_TOKEN="$2"
      shift # past argument
      shift # past value
      ;;
    --version) # Runtime search option #1: Digital.ai Release Runner version to search for matching agent runtimes
      INPUT_VERSION="$2"
      shift # past argument
      shift # past value
      ;;
    --runtimeName) # Runtime search option #2: Name of agent runtime to use
      INPUT_RUNTIME_NAME="$2"
      shift # past argument
      shift # past value
      ;;
    --runtimeId) # Runtime search option #3: ID of agent runtime
      INPUT_RUNTIME_ID="$2"
      shift # past argument
      shift # past value
      ;;
    --domain) # Vanity domain for the tenant
      INPUT_DOMAIN="$2"
      shift # past argument
      shift # past value
      ;;
    --account) # Account id for the tenant
      INPUT_ACCOUNT="$2"
      shift # past argument
      shift # past value
      ;;
    --agentAlias) # the namespace of the agent instance in k3d
      INPUT_ALIAS="$2"
      shift # past argument
      shift # past value
      ;;
    --releaseToken) # token for registering Digital.ai Release Runner with
      RUNNER_REGISTRATION_TOKEN="$2"
      shift # past argument
      shift # past value
      ;;
    -*|--*)
      echo "Unknown option $1"
      exit 1
      ;;
  esac
  if [ ${ARG_COUNT} -eq $# ]; then
    echo "Arguments have not been processed correctly, there should be fewer arguments remaining after processing one"
    exit 1
  fi
done

#####################################################
# Check input params
#####################################################

# Check auth specific arguments
if [ -z ${INPUT_TOKEN} ]; then
  if [ ! -z ${INPUT_USER} ] && [ ! -z ${INPUT_PW} ]; then
    TENANT_USER="${INPUT_USER}"
    TENANT_PW="${INPUT_PW}"
  else
    echo "Use --token to define the bearer token to use or specify username and password with --user and --pw"
    MISSING_REQUIRED=true
  fi
else
  TENANT_TOKEN="${INPUT_TOKEN}"
fi

# Check agent runtime search specific arguments
if [ -z ${INPUT_RUNTIME_ID} ] && [ -z ${INPUT_RUNTIME_NAME} ] && [ -z ${INPUT_VERSION} ]; then
    echo "Use one of the following options to select a agent runtime to create the agent from:"
    echo "    --runtimeId <id> : to search by id for the agent runtime"
    echo "    --runtimeName <name> : to search for agent runtimes matching the name"
    echo "    --version <version> : to search for agent runtimes using a specific Digital.ai Release Runner image version"
    MISSING_REQUIRED=true
else
  if [ ! -z ${INPUT_RUNTIME_ID} ]; then
    AGENT_RUNTIME_ID=${INPUT_RUNTIME_ID}
  elif [ ! -z ${INPUT_RUNTIME_NAME} ]; then
    SEARCH_NAME=${INPUT_RUNTIME_NAME}
  else
    SEARCH_VERSION=${INPUT_VERSION}
  fi
fi

if [ -z ${INPUT_DOMAIN} ]; then
  echo "Use --domain to define the vanity domain for the tenant"
  MISSING_REQUIRED=true
else
  VANITY_DOMAIN="${INPUT_DOMAIN}"
fi

if [ -z ${INPUT_ACCOUNT} ]; then
  echo "Use --account to define the account id of the tenant"
  MISSING_REQUIRED=true
else
  ACCOUNT_ID="${INPUT_ACCOUNT}"
fi

if [ -z ${INPUT_ALIAS} ]; then
  echo "Use --agentAlias to define the alias for the agent instance"
  MISSING_REQUIRED=true
else
  AGENT_ALIAS="${INPUT_ALIAS}"
fi

if [ ${MISSING_REQUIRED} ]; then
  exit 1
fi

# Create the token if necessary
if [ -z ${TENANT_TOKEN} ]; then
  TOKEN_ENDPOINT=$(curl --silent "${API_URL}/identity/v1/accounts/${VANITY_DOMAIN}/.well-known/openid-configuration" \
    | jq -r .token_endpoint)

  TENANT_TOKEN=$(curl --silent --request POST "${TOKEN_ENDPOINT}" \
    --header 'Content-Type: application/x-www-form-urlencoded' \
    --data-urlencode 'grant_type=client_credentials' \
    --data-urlencode "client_secret=${TENANT_PW}" \
    --data-urlencode "client_id=${TENANT_USER}" \
    --data-urlencode 'scope=openid dai-svc' \
    | jq -r .access_token)
fi

dumpAllAgentRuntimes() {
  echo "These are all the available agent runtime definitions:"
  curl --silent --request GET "${API_URL}/workload/v1/agent_runtimes" \
        --header "Authorization: Bearer ${TENANT_TOKEN}" \
        | jq '.agent_runtimes[] | {id, name, images}'
}

# If runtime ID wasn't supplied search by name or version to get the id
if [ -z ${AGENT_RUNTIME_ID} ]; then
  if [ ! -z ${SEARCH_NAME} ]; then
    # Search by runtime name
    RUNTIME_IDS=( $(curl --silent --request GET "${API_URL}/workload/v1/agent_runtimes?filter=name:${SEARCH_NAME}" \
      --header "Authorization: Bearer ${TENANT_TOKEN}" \
      | jq -r '.agent_runtimes[] | .id') )

    if [ ${#RUNTIME_IDS[@]} -eq 0 ]; then
      echo "No agent runtime definitions searching by name '${SEARCH_NAME}', an agent runtime may need to be created in the platform"
      dumpAllAgentRuntimes
      exit 1
    elif [ ${#RUNTIME_IDS[@]} -gt 1 ]; then
      echo "Too many agent runtime definitions found searching by name '${SEARCH_NAME}', use --version or --runtimeId instead to find the agent runtime to use"
      dumpAllAgentRuntimes
      exit 1
    else
      AGENT_RUNTIME_ID=${RUNTIME_IDS[0]}
    fi
  else
    # Search by agent runtime image version
    RUNTIME_IDS=( $(curl --silent --request GET "${API_URL}/workload/v1/agent_runtime_images?filter=name:release-runner" \
      --header "Authorization: Bearer ${TENANT_TOKEN}" \
      | jq --arg tag "${SEARCH_VERSION}" \
        -r '.agent_runtime_images[] | select(.latest_tag == $tag) | .agent_runtime_id') )

    if [ ${#RUNTIME_IDS[@]} -eq 0 ]; then
      echo "No agent runtime definitions found using image version '${SEARCH_VERSION}', an agent runtime may need to be created in the platform"
      dumpAllAgentRuntimes
      exit 1
    elif [ ${#RUNTIME_IDS[@]} -gt 1 ]; then
      echo "Too many definitions found using image version '${SEARCH_VERSION}', use --runtimeName or --runtimeId instead to find the agent runtime to use"
      dumpAllAgentRuntimes
      exit 1
    else
      AGENT_RUNTIME_ID=${RUNTIME_IDS[0]}
    fi
  fi
fi

echo "Using agent runtime id ${AGENT_RUNTIME_ID}"
AGENT_RUNTIME=$(curl --silent --request GET "${API_URL}/workload/v1/agent_runtimes/${AGENT_RUNTIME_ID}" \
  --header "Authorization: Bearer ${TENANT_TOKEN}" \
  | jq -r '.agent_runtime | del(.k8s_template)')

if [ -z "${AGENT_RUNTIME}" ] || [ "${AGENT_RUNTIME}" == "null" ]; then
  echo "Agent runtime definition with id ${AGENT_RUNTIME_ID} can't be found"
  dumpAllAgentRuntimes
  exit 1
fi

echo "Agent runtime definition:"
echo "${AGENT_RUNTIME}" | jq
VARIABLES_JSON=$(echo "${AGENT_RUNTIME}" | jq '.variables | with_entries(select(.value | match("<.*>")))')
VARIABLE_NAMES=( $(echo "${VARIABLES_JSON}" | jq -r 'keys | .[]') )

echo "Variables that need to be defined in agent instance:"
for VARIABLE_NAME in "${VARIABLE_NAMES[@]}"; do
  if [ ! -z "${!VARIABLE_NAME}" ]; then
    echo "Defining ${VARIABLE_NAME} as value ${!VARIABLE_NAME}"
    VARIABLES_JSON=$(echo "${VARIABLES_JSON}" | jq --arg key "${VARIABLE_NAME}" --arg value "${!VARIABLE_NAME}" '.[$key] |= $value')
  else
    echo "Can't find value for script variable named: '${VARIABLE_NAME}'"
  fi
done

# Check VARIABLES_JSON to make sure all values are filled in
MISSING_VARS=$(echo "${VARIABLES_JSON}" | jq -r 'with_entries(select(.value | match("<.*>"))) | keys | .[]')
if [ ! -z ${MISSING_VARS} ]; then
  echo "There are variables needed in JSON definition that are not defined in this script:"
  echo "${MISSING_VARS}"
  exit 1
fi

AGENT_INSTANCE_POST_BODY=$(jq --null-input \
  --arg alias "${AGENT_ALIAS}" \
  --arg account "${ACCOUNT_ID}" \
  --arg runtime "${AGENT_RUNTIME_ID}" \
  --argjson variables "${VARIABLES_JSON}" \
  '{"account_id" : $account, "agent_id": $runtime, "alias": $alias, $variables}')

echo "Creating agent instance..."
RESPONSE=$(curl --silent --request POST "${API_URL}/workload/v1/agent_instances" \
  --header "Authorization: Bearer ${TENANT_TOKEN}" \
  --header 'Accept: application/json' \
  --header 'Content-Type: application/json' \
  --data "${AGENT_INSTANCE_POST_BODY}")

ERROR=$(echo "${RESPONSE}" | jq -r '.error.message')
if  [ -z "${ERROR}" ] || [ "${ERROR}" == "null" ]; then
  echo "${RESPONSE}" | jq -r '.agent_instance | del(.k8s_template)'
else
  echo "Creating agent instance failed, reason: ${ERROR}"
  echo "${RESPONSE}" | jq
  exit 1
fi

---
title: "Getting started with runner"
author: "Dawid Kałędkowski"
date: "`r Sys.Date()`"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Getting started with runner}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## About

Package contains standard running functions (aka. rolling) with additional 
options like varying window size, lagging, handling missings and windows 
depending on date. `runner` brings also rolling streak and rolling which, what 
extends beyond range of functions already implemented in R packages. This 
package can be successfully used to manipulate and aggregate time series or 
longitudinal data.

## Using runner

`runner` package provides functions applied on running windows. The most 
universal function is `runner::runner` which gives user possibility to apply 
any R function `f` in running window. In example below 4-months correlation 
is calculated lagged by 
1 month.

```{r eval=FALSE}
library(runner)

x <- data.frame(
  date = seq.Date(Sys.Date(), Sys.Date() + 365, length.out = 20),
  a = rnorm(20),
  b = rnorm(20)
)

runner(
  x,
  lag = "1 months",
  k = "4 months",
  idx = x$date,
  f = function(x) {
    cor(x$a, x$b)
  }
)
```

There are different kinds of running windows and all of them are implemented in
`runner`.

## Running windows

Following diagram illustrates what running windows are - in this case running 
windows of length `k = 4`. For each of 15 elements of a vector each window 
contains current 4 elements.

![](images/incrementalindex.png)


### Window size
`k` denotes number of elements in window. If `k` is a single value then window 
size is constant for all elements of x. For varying window size one should specify 
`k` as integer vector of `length(k) == length(x)` where each element of `k` 
defines window length. If `k` is empty it means that window will be cumulative 
(like `base::cumsum`). Example below illustrates window of `k = 4` for 10th 
element of vector `x`.  

![](images/constantwindow.png)

```{r eval=FALSE}
runner(1:15, k = 4)
```

### Window lag
`lag` denotes how many observations windows will be lagged by. If `lag` is a 
single value than it is constant for all elements of x. For varying lag size one 
should specify `lag` as integer vector of `length(lag) == length(x)` where each 
element of `lag` defines lag of window. Default value of `lag = 0`. Example 
below illustrates window of `k = 4` lagged by `lag = 2` for 10-th element of 
vector `x`. Lag can also be negative value, which shifts window forward instead 
of backward.

![](images/laggedwindowklag.png)
```{r eval=FALSE}
runner(
  1:15,
  k = 4,
  lag = 2
)
```

---
title: "Built-in functions"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Built-in functions}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

This tutorial presents built-in functions in runner package which goal is to 
maximize performance. Even if one can apply any R function with `runner::runner`,
built-in functions are multiple times faster than R equivalent. Before you 
proceed further to this tutorial, make sure you know what the
["running functions are"](getting_started_with_runner.html).

## Running aggregations

### Running `<mean,sum,min,max>_run`

Runner provides basic aggregation methods calculated within running windows. 
Below example showing some functions behavior for different arguments setup. 
`min_run` calculates current minimum for all elements of the vector. Let's take 
a look at 8'th element of the vector which `min_run` is calculated on.  
First setup uses default values, so algorithm is looking for minimum value in 
all elements before actual (i=8). By default missing values are removed before 
calculations by argument `na_rm = TRUE`, and also window is not specified. The 
default is equivalent of `base::cummin` with additional option to ignore `NA` 
values. In second example within window k=5, the lowest value is -3. In the last 
example minimum is not available due to existence of `NA`. Graphical example is 
reproduced below in the code.

![](images/running_minimum.png)

```{r min_run_example, echo=TRUE}
library(runner)
x <- c(1, -5, 1, -3, NA, NA, NA, 1, -1, NA, -2, 3)

data.frame(
  x,
  default = min_run(x, na_rm = TRUE),
  k_5     = min_run(x, k = 5, na_rm = TRUE),
  narm_f  = min_run(x, na_rm = FALSE)
)
```

In above example constant `k = 5` has been used which means that for each element, 
current minimum is calculated on last 5-elements. It may happen that one can have
time series where elements are not equally spaced in time, which effects in `k = 5`
not constant. In example below 5-days sum is calculated. To achieve this, one should
put date variable to `idx` argument.  
Illustration below shows two sums calculated in 5-days window span. In both cases
5-days fit in 3-elements windows. Equivalent R code below.

![](images/options_idx.png)

```{r idx_run_example, echo=TRUE}
x <- c(-0.5910, 0.0266, -1.5166, -1.3627, 1.1785, -0.9342, 1.3236, 0.6249)
idx <- as.Date(c(
  "1970-01-03", "1970-01-06", "1970-01-09", "1970-01-12",
  "1970-01-13", "1970-01-16", "1970-01-17", "1970-01-19"
))

sum_run(x, k = 5, idx = idx)
```

Specifying `lag` argument shift of the window by number of elements or time periods
(if `idx` is specified). 

```{r lag_run_example, echo=TRUE}
x <- c(-0.5910, 0.0266, -1.5166, -1.3627, 1.1785, -0.9342, 1.3236, 0.6249)
idx <- as.Date(c(
  "1970-01-03", "1970-01-06", "1970-01-09", "1970-01-12",
  "1970-01-13", "1970-01-16", "1970-01-17", "1970-01-19"
))

sum_run(x, k = 5, lag = 2, idx = idx)
```


### Running streak

To count consecutive elements in specified window one can use `streak_run`. Following 
figure illustrates how streak is calculated with three different options setup for
9th element of the input vector `x`. First shows default configuration, with full
window and `na_rm = TRUE`. Second example count within `k = 4` window with count
reset on `NA`. Last example counting streak with continuation after `NA`. 
Visualization also supported with corresponding R code.

![](images/running_streaks.png)

```{r}
x <- c("A", "B", "A", "A", "B", "B", "B", NA, "B", "B", "A", "B")
data.frame(
  x,
  s0 = streak_run(x),
  s1 = streak_run(x, k = 4, na_rm = FALSE),
  s2 = streak_run(x, k = 4)
)
```

Streak is often used in sports to count number of wins or loses of the team/player.
To count consecutive wins or loses in 5-days period, one have to specify `k = 5` 
and include dates into `idx` argument. Specifying `lag` shifts window bounds by 
number of elements or time periods (if `idx` is specified).

```{r}
x <- c("W", "W", "L", "L", "L", "W", "L", "L")
idx <- as.Date(c(
  "2019-01-03", "2019-01-06", "2019-01-09", "2019-01-12",
  "2019-01-13", "2019-01-16", "2019-01-17", "2019-01-19"
))

data.frame(
  idx,
  x,
  streak_5d     = streak_run(x, k = 5, idx = idx),
  streak_5d_lag = streak_run(x, k = 5, lag = 1, idx = idx)
)
```

## Utility functions

### Improved lag

Idea of `lag_run` is the same as well known `stats::lag`, with distinction that
`lag_run` can depend on time or any other indexes passed to `idx` argument. 
This means that `lag_run` can shift by `lag` elements of the vector or by `lag` 
time periods (if `idx` is specified).  

```{r}
x <- c(-0.5910, 0.0266, -1.5166, -1.3627, 1.1785, -0.9342, 1.3236, 0.6249)
idx <- as.Date(c(
  "1970-01-03", "1970-01-06", "1970-01-09", "1970-01-12",
  "1970-01-13", "1970-01-16", "1970-01-17", "1970-01-19"
))

lag_run(x, lag = 3, idx = idx)
```

### Filling missing values

Function used to replace `NA` with previous non-NA element. To understand how 
`fill_run` works, take a look on illustration. Row 'x' represents input, and
another rows represent output with `NA` replaced by `fill_run` with different 
options setup (`run_for_first = TRUE` and `only_within = TRUE` respectively). 
By default, `fill_run` replaces all `NA` if they were preceded by any value. If 
`NA` appeared in the beginning of the vector then it would not be replaced. But 
if user specify `run_for_first = TRUE` initial empty values values will be 
replaced by next non-empty value. Option `only_within = TRUE` means that `NA` 
values would be replaced if they were surrounded by pair of identical values. No 
windows provided in this functionality.

![](images/fill_run.png)

```{r}
x <- c(NA, NA, "b", "b", "a", NA, NA, "a", "b", NA, "a", "b")
data.frame(x,
  f1 = fill_run(x),
  f2 = fill_run(x, run_for_first = TRUE),
  f3 = fill_run(x, only_within = TRUE)
)
```

### Running which  

To obtain index number of element matching some condition in window, one can use 
`which_run`, which returns index of  `TRUE` element appeared before n-th element 
of a vector. If `na_rm = TRUE` is specified, missing is treated as `FALSE`, and
is ignored while searching for `TRUE`. While user set `na_rm = FALSE` like in
second example, function returns `NA`, because in following window `TRUE` appears
after missing and it's impossible to be certain which is first (missing is an
element of unknown value - could be `TRUE` or `FALSE`).


![](images/running_which_more.png)

```{r}
x <- c(T, T, T, F, NA, T, F, NA, T, F, T, F)
data.frame(
  x,
  s0 = which_run(x, which = "first"),
  s1 = which_run(x, na_rm = FALSE, k = 5, which = "first"),
  s2 = which_run(x, k = 5, which = "last")
)
```


`which` argument ('first' or 'last') used with `which_run` determines which index
of matching element should be returned from window. In below illustration in 
`k = 4` elements window there are two `TRUE` values, and depending on `which`
argument output is equal `2`  or `4`. 

![](images/options_which_first_last.png)
